Package: curatedPCaData
Title: Curated Prostate Cancer Data
Version: 1.8.0
Date: 2024-01-10
Authors@R: c(person("Teemu Daniel", "Laajala", email = "teelaa@utu.fi", 
        role = c("aut", "cre"), comment = c(ORCID = "0000-0002-7016-7354")),
    person("Jordan", "Creed", email = "jordan.h.creed@moffitt.org", 
		role = "ctb"),
    person("Christelle", "Colin Leitzinger", email = 
	    "christelle.colinleitzinger@moffitt.org", role = "ctb"),
    person("Varsha", "Sreekanth", email = "varsha.sreekanth@cuanschutz.edu", 
	    role = "ctb"), 
    person("Federico", "Calboli", email = "federico.calboli@luke.fi", 
	    role = "ctb"),
    person("Kalaimathy", "Singaravelu", email = "kalsin@utu.fi", role = "ctb"),
    person("Michael", "Orman", email = "michael.orman@cuanschutz.edu", 
	    role = "ctb"),
    person("Alex", "Soupir", email = "Alex.Soupir@moffitt.org", role = "ctb"),
    person("Anni", "Halkola", email = "ansuha@utu.fi", role = "ctb"))
Description: The package curatedPCaData offers a selection of annotated prostate
 cancer datasets featuring multiple omics, manually curated metadata, and 
 derived downstream variables. The studies are offered as MultiAssayExperiment 
 (MAE) objects via ExperimentHub, and comprise of clinical characteristics tied 
 to gene expression, copy number alteration and somatic mutation data. Further, 
 downstream features computed from these multi-omics data are offered. Multiple 
 vignettes help grasp characteristics of the various studies and provide example
 exploratory and meta-analysis of leveraging the multiple studies provided 
 here-in.
License: CC BY 4.0
Encoding: UTF-8
RoxygenNote: 7.2.3
VignetteBuilder: knitr
biocViews: ExperimentHub, ExperimentData, ProstateCancerData,
        CancerData, Homo_sapiens_Data, MicroarrayData, RNASeqData,
        ExpressionData, CopyNumberVariationData, Somatic, GEO,
        ReproducibleResearch
URL: https://github.com/Syksy/curatedPCaData
BugReports: https://github.com/Syksy/curatedPCaData/issues
Depends: R (>= 4.4.0), S4Vectors (>= 0.23.18), MultiAssayExperiment,
        RaggedExperiment
Imports: ExperimentHub, AnnotationHub, utils, methods, rlang, stats,
        reshape2
Suggests: BiocStyle, knitr, ggplot2, rmarkdown, survival, survminer,
        ComplexHeatmap, corrplot, formatR
git_url: https://git.bioconductor.org/packages/curatedPCaData
git_branch: RELEASE_3_23
git_last_commit: 060f061
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-05-05
NeedsCompilation: no
Packaged: 2026-05-05 15:19:15 UTC; biocbuild
Author: Teemu Daniel Laajala [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-7016-7354>),
  Jordan Creed [ctb],
  Christelle Colin Leitzinger [ctb],
  Varsha Sreekanth [ctb],
  Federico Calboli [ctb],
  Kalaimathy Singaravelu [ctb],
  Michael Orman [ctb],
  Alex Soupir [ctb],
  Anni Halkola [ctb]
Maintainer: Teemu Daniel Laajala <teelaa@utu.fi>

# curatedPCaData <img src="man/figures/hex.png" align="right" height="139" />

<!-- badges: start -->
<!-- badges: end -->

## Overview

`curatedPCaData` is a collection of publically available and annotated
data resources concerning prostate cancer.

## Citation

If you use `curatedPCaData`, please consider adding the following
citation:

    @article {Laajala2023.01.17.524403,
        author = {Laajala, Teemu D and Sreekanth, Varsha and Soupir, Alex and Creed, Jordan and Halkola, Anni S and Calboli, Federico CF and Singaravelu, Kalaimathy and Orman, Michael and Colin-Leitzinger, Christelle and Gerke, Travis and Fidley, Brooke L. and Tyekucheva, Svitlana and Costello, James C},
        title = {A harmonized resource of integrated prostate cancer clinical, -omic, and signature features},
        year = {2023},
        doi = {10.1038/s41597-023-02335-4},
        URL = {https://www.nature.com/articles/s41597-023-02335-4},
        journal = {Scientific Data}
    }

## Installation

### Bioconductor installation

In order to install the package from Bioconductor, make sure
`BiocManager` is installed and then call the function to install
`curatedPCaData`:

    if (!require("BiocManager", quietly = TRUE))
        install.packages("BiocManager")

    BiocManager::install("curatedPCaData")

### GitHub installation

A download link to the latest pre-built `curatedPCaData` tarball is
available on the right-side in GitHub under
[Releases](https://github.com/Syksy/curatedPCaData/releases).

You can also install `curatedPCaData` from GitHub inside R with:

    # install.packages("devtools")
    devtools::install_github("Syksy/curatedPCaData")

To build the package tarball from a cloned git repo, run the following
in terminal / command prompt while in the root of the project:

    R CMD build curatedPCaData

It is then possible to install the self-built tarball:

    R CMD INSTALL curatedPCaData_x.y.z.tar.gz

Note that building the package locally will require dependencies to be
present for the R installation.

## Usage

### Vignettes

`curatedPCaData` delivers with basic vignette()s displaying the
package’s generic use data retrieval and basic processing in R. The
vignette `overview` is intended for gaining a first-line comprehensive
view into the package’s contents. The intention is to display the basic
functionality of the package as an `ExperimentHub` resource.

A sister package, `curatedPCaWorkflow` (GitHub [link
here](https://github.com/Syksy/curatedPCaWorkflow)), serves multiple
specialized vignettes that delve deeper into analysis and further
processing of the data. This workflow package reproduces the results
presented in Laajala et al., and provides useful insight and examples
for those looking to further leverage use of the multi-omics data
provided in `curatedPCaData`.

### Downloading data

The function `getPCa` is the primary means of extracting data from a
cohort. It will automatically create a `MultiAssayExperiment`-object of
the study:

    library(curatedPCaData)

    mae_tcga <- getPCa("tcga")

    class(mae_tcga)
    ## [1] "MultiAssayExperiment"
    ## attr(,"package")
    ## [1] "MultiAssayExperiment"
    names(mae_tcga)
    ##  [1] "cna.gistic"   "gex.rsem.log" "mut"          "cibersort"    "xcell"       
    ##  [6] "epic"         "quantiseq"    "mcp"          "estimate"     "scores"

### Brief examples

Simple example use of curated datasets and ’omics there-in:

    mae_taylor <- getPCa("taylor")
    mae_sun <- getPCa("sun")

    mae_tcga
    ## A MultiAssayExperiment object of 10 listed
    ##  experiments with user-defined names and respective classes.
    ##  Containing an ExperimentList class object of length 10:
    ##  [1] cna.gistic: matrix with 23151 rows and 492 columns
    ##  [2] gex.rsem.log: matrix with 19658 rows and 461 columns
    ##  [3] mut: RaggedExperiment with 30897 rows and 495 columns
    ##  [4] cibersort: matrix with 22 rows and 461 columns
    ##  [5] xcell: matrix with 39 rows and 461 columns
    ##  [6] epic: matrix with 8 rows and 461 columns
    ##  [7] quantiseq: matrix with 11 rows and 461 columns
    ##  [8] mcp: matrix with 11 rows and 461 columns
    ##  [9] estimate: matrix with 4 rows and 461 columns
    ##  [10] scores: matrix with 4 rows and 461 columns
    ## Functionality:
    ##  experiments() - obtain the ExperimentList instance
    ##  colData() - the primary/phenotype DataFrame
    ##  sampleMap() - the sample coordination DataFrame
    ##  `$`, `[`, `[[` - extract colData columns, subset, or experiment
    ##  *Format() - convert into a long or wide DataFrame
    ##  assays() - convert ExperimentList to a SimpleList of matrices
    ##  exportClass() - save data to flat files

    mae_tcga[["gex.rsem.log"]][1:4, 1:4]
    ##          TCGA.G9.6348.01 TCGA.CH.5766.01 TCGA.EJ.A65G.01 TCGA.EJ.5527.01
    ## A1BG              4.3733          6.0244          7.4927          3.7801
    ## A1BG-AS1          4.5576          6.3326          6.7861          4.5912
    ## A1CF              0.4008          0.7574          0.0000          0.0000
    ## A2M              14.3952         12.8331         12.5017         14.2289

    mae_tcga[["cna.gistic"]][1:4, 1:4]
    ##       TCGA.2A.A8VL.01 TCGA.2A.A8VO.01 TCGA.2A.A8VT.01 TCGA.2A.A8VV.01
    ## A1BG                0               0               0               0
    ## A1CF                0               0              -1               0
    ## A2M                 0               0              -1               0
    ## A2ML1               0               0              -1               0

    colData(mae_tcga)[1:3, 1:5]
    ## DataFrame with 3 rows and 5 columns
    ##                  study_name   patient_id     sample_name        alt_sample_name
    ##                 <character>  <character>     <character>            <character>
    ## TCGA.2A.A8VL.01        TCGA TCGA.2A.A8VL TCGA.2A.A8VL.01 F9F392D3-E3C0-4CF2-A..
    ## TCGA.2A.A8VO.01        TCGA TCGA.2A.A8VO TCGA.2A.A8VO.01 0BD35529-3416-42DD-A..
    ## TCGA.2A.A8VT.01        TCGA TCGA.2A.A8VT TCGA.2A.A8VT.01 BFECF807-0658-417B-9..
    ##                 overall_survival_status
    ##                               <integer>
    ## TCGA.2A.A8VL.01                       0
    ## TCGA.2A.A8VO.01                       0
    ## TCGA.2A.A8VT.01                       0

    mae_taylor
    ## A MultiAssayExperiment object of 11 listed
    ##  experiments with user-defined names and respective classes.
    ##  Containing an ExperimentList class object of length 11:
    ##  [1] cna.gistic: matrix with 17832 rows and 194 columns
    ##  [2] cna.logr: matrix with 18062 rows and 218 columns
    ##  [3] gex.rma: matrix with 17410 rows and 179 columns
    ##  [4] mut: RaggedExperiment with 90 rows and 43 columns
    ##  [5] cibersort: matrix with 22 rows and 179 columns
    ##  [6] xcell: matrix with 39 rows and 179 columns
    ##  [7] epic: matrix with 8 rows and 179 columns
    ##  [8] quantiseq: matrix with 11 rows and 179 columns
    ##  [9] mcp: matrix with 11 rows and 179 columns
    ##  [10] estimate: matrix with 4 rows and 179 columns
    ##  [11] scores: matrix with 4 rows and 179 columns
    ## Functionality:
    ##  experiments() - obtain the ExperimentList instance
    ##  colData() - the primary/phenotype DataFrame
    ##  sampleMap() - the sample coordination DataFrame
    ##  `$`, `[`, `[[` - extract colData columns, subset, or experiment
    ##  *Format() - convert into a long or wide DataFrame
    ##  assays() - convert ExperimentList to a SimpleList of matrices
    ##  exportClass() - save data to flat files

    mae_sun
    ## A MultiAssayExperiment object of 8 listed
    ##  experiments with user-defined names and respective classes.
    ##  Containing an ExperimentList class object of length 8:
    ##  [1] gex.rma: matrix with 12784 rows and 79 columns
    ##  [2] cibersort: matrix with 22 rows and 79 columns
    ##  [3] xcell: matrix with 39 rows and 79 columns
    ##  [4] epic: matrix with 8 rows and 79 columns
    ##  [5] quantiseq: matrix with 11 rows and 79 columns
    ##  [6] estimate: matrix with 4 rows and 79 columns
    ##  [7] scores: matrix with 4 rows and 79 columns
    ##  [8] mcp: matrix with 11 rows and 79 columns
    ## Functionality:
    ##  experiments() - obtain the ExperimentList instance
    ##  colData() - the primary/phenotype DataFrame
    ##  sampleMap() - the sample coordination DataFrame
    ##  `$`, `[`, `[[` - extract colData columns, subset, or experiment
    ##  *Format() - convert into a long or wide DataFrame
    ##  assays() - convert ExperimentList to a SimpleList of matrices
    ##  exportClass() - save data to flat files

For further details on the provided datasets and extra parameters for
handling data extraction, please consult the `overview`-vignette.

### Multiple summarization functions Provides user-friendly formatted
### information on available data and contents there-in

#' Create summary tables for colData metadata in curatedPCaData
#'
#' Create a variable value availability tables; NA-value in addition to provided
#' 'vals' and Other-values for debugging or anomalies
#'
#' @param maes List of MultiAssayExperiment objects to summarize
#' @param var.name Name of the metadata variable to look for in colData
#' @param vals Possible values for the metadata variable to tabulate
#' @param nas Whether NA or values other than those contained in 'vals' should 
#' be appended as extra columns
#'
#' @return A matrix describing the tabulates 'vals' and their proportions along 
#' with missingness
#'
#' @examples
#' mae_taylor <- getPCa('taylor')
#' mae_tcga <- getPCa('tcga')
#' getPCaSummaryTable(maes = list(Taylor = mae_taylor, TCGA = mae_tcga), 
#'     var.name = 'gleason_grade', vals = 5:10)
#'
#' @export getPCaSummaryTable
getPCaSummaryTable <- function(maes, var.name, vals, nas = TRUE) {
    mat <- matrix(NA, nrow = length(maes), ncol = ifelse(nas, length(vals) + 2, 
        length(vals)))
    rownames(mat) <- names(maes)
    for (i in seq_len(length(maes))) {
        # Get observed metadata values
        obs <- MultiAssayExperiment::colData(maes[[i]])[, var.name]
        # Iterate possible variable values
        for (j in seq_len(length(vals))) {
            if (!sum(obs == vals[j], na.rm = TRUE) == 0) {
                mat[i, j] <- paste0(sum(obs == vals[j], na.rm = TRUE), " (", 
                round(100 * sum(obs == vals[j], na.rm = TRUE)/length(obs), 0),
                "%)")
            } else {
                mat[i, j] <- "-"
            }
        }

    }
    # If Other and N/A values should be reported
    if (nas) {
        colnames(mat) <- c(vals, "Other", "N/A")
        # Other values
        vals <- c(vals, NA, NA_real_, NA_character_)
        mat[i, ncol(mat) - 1] <- paste0(sum(!obs %in% vals, na.rm = TRUE), " (",
            round(100 * sum(!obs %in% vals, na.rm = TRUE)/length(obs), 0), "%)")
        # NA-values
        mat[i, ncol(mat)] <- paste0(sum(is.na(obs), na.rm = TRUE), " (", 
            round(100 * sum(is.na(obs), na.rm = TRUE)/length(obs), 0), "%)")
    } else {
        colnames(mat) <- vals
    }
    mat
}

#' Create survival summary for metadata in curatedPCaData
#'
#' Create summary for survival-like columns (0/1 event with follow-up time) for 
#' colData metadata in curatedPCaData
#'
#' @param maes List of MultiAssayExperiment objects to summarize
#' @param event.name Name for the colData column for the end-point event; 
#' typically one of 'days_to_disease_specific_recurrence' or 
#' 'days_to_overall_survival'
#' @param time.name Name for the colData column for the time for the end-point 
#' until event or censoring; typically one of 
#' 'disease_specific_recurrence_status' or 'overall_survival_status'
#'
#' @return A matrix describing the event and follow-up information as character 
#' strings
#'
#' @examples
#' mae_taylor <- getPCa('taylor')
#' mae_tcga <- getPCa('tcga')
#' getPCaSummarySurv(maes = list(Taylor = mae_taylor, TCGA = mae_tcga), 
#'     event.name = 'disease_specific_recurrence_status', time.name = 
#'     'days_to_disease_specific_recurrence')
#'
#' @importFrom stats quantile
#' @export getPCaSummarySurv
getPCaSummarySurv <- function(maes, event.name, time.name) {
    mat <- matrix(NA, nrow = length(maes), ncol = 5)
    rownames(mat) <- names(maes)
    colnames(mat) <- c("0 (no event)", "1 (event)", "N/A (event)", 
        "Time (days, quantiles)", "N/A (time)")
    for (i in seq_len(length(maes))) {
        times <- MultiAssayExperiment::colData(maes[[i]])[, time.name]
        events <- MultiAssayExperiment::colData(maes[[i]])[, event.name]
        ifelse(all(is.na(events)), mat[i, 1] <- "-", mat[i, 1] <- paste0(sum(
            events == 0, na.rm = TRUE), " (", round(100 * sum(events == 0, 
            na.rm = TRUE)/length(events), 0), "%)"))
        ifelse(all(is.na(events)), mat[i, 2] <- "-", mat[i, 2] <- paste0(sum(
            events == 1, na.rm = TRUE), " (", round(100 * sum(events == 1, 
            na.rm = TRUE)/length(events), 0), "%)"))
        mat[i, 3] <- paste0(sum(is.na(events)), " (", round(100 * sum(
            is.na(events))/length(events), 0), "%)")
        qs <- round(quantile(times, na.rm = TRUE), 0)
        ifelse(all(is.na(qs)), mat[i, 4] <- "-", mat[i, 4] <- paste0("[", qs[1],
            ",", qs[2], ",", qs[3], ",", qs[4], ",", qs[5], "]"))
        mat[i, 5] <- paste0(sum(is.na(times)), " (", round(100 * sum(
            is.na(times))/length(times), 0), "%)")
    }
    mat
}

#' Create a summary table for sample counts for different omics across the 
#' datasets in curatedPCaData
#'
#' Create two types of summary matrices; first one takes all unique assay names,
#' and summarizes sample counts available for all provided studies. The second 
#' matrix takes gene expression, copy number alteration, and somatic mutation 
#' data, and displays sample counts for each omic individually, as well as all 
#' combinations of intersections for samples available for multi-omics.
#'
#' @param maes List of MultiAssayExperiment objects to summarize
#'
#' @return A list with two elements: first is a matrix depicting sample counts 
#' in each unique assay name for the studies; 
#' second one is a matrix with sample count overlap between the three main omics
#' (GEX = gene expression; CNA = copy number alteration; MUT = somatic 
#' mutations).
#'
#' @examples
#' mae_taylor <- getPCa('taylor')
#' mae_tcga <- getPCa('tcga')
#' getPCaSummarySamples(maes = list(Taylor = mae_taylor, TCGA = mae_tcga))
#'
#' @export getPCaSummarySamples
getPCaSummarySamples <- function(maes) {
    # Extract up-to-date assaynames over all MAE-objects
    assaynames <- c()
    for (mae in maes) {
        assaynames <- c(assaynames, names(mae))
    }
    # Unique slot names
    assaynames <- unique(assaynames)
    # Create n count or absent (NA) matrix to be printed out
    assaymat <- matrix("", nrow = length(assaynames), ncol = length(maes))
    # Create a list of lists for sample names in different omics
    sampnames <- list()
    rownames(assaymat) <- sort(assaynames)  # Alphabetic ordering
    colnames(assaymat) <- names(maes)
    for (col in seq_len(length(maes))) {
        sampnames[[length(sampnames) + 1]] <- list()
        mae <- maes[[col]]
        for (row in seq_len(nrow(assaymat))) {
            if (rownames(assaymat)[row] %in% names(mae)) {
                assaymat[row, col] <- 
                    length(colnames(mae[[rownames(assaymat)[row]]]))
                sampnames[[length(sampnames)]][[length(sampnames[[
                    length(sampnames)]]) + 1]] <- 
                        colnames(mae[[rownames(assaymat)[row]]])
                names(sampnames[[length(sampnames)]])[length(sampnames[[
                    length(sampnames)]])] <- rownames(assaymat)[row]
            }
        }
    }
    # Give MAE names
    names(sampnames) <- names(maes)
    # Transpose for more user-friendly printing in rmarkdown
    assaymat <- t(assaymat)
    # Which MAEs had 2 or more omics
    multiomics <- names(which(unlist(lapply(sampnames, FUN = function(x) {
        length(names(x)) > 1
    }))))
    # Create an overlap N count matrix for GEX & CNA, CNA & MUT, GEX & CNA &
    # MUT based on sample names
    overmat <- matrix("", ncol = 7, nrow = length(multiomics))
    colnames(overmat) <- c("GEX", "CNA", "MUT", "GEX & CNA", "GEX & MUT", 
        "CNA & MUT", "GEX & CNA & MUT")
    rownames(overmat) <- multiomics
    for (mult in multiomics) {
        samps <- sampnames[[mult]]
        gex <- samps[[grep("gex", names(samps))[1]]]
        cna <- samps[[grep("cna", names(samps))[1]]]
        mut <- samps[[grep("mut", names(samps))[1]]]
        gex_cna <- length(intersect(gex, cna))
        gex_mut <- length(intersect(gex, mut))
        cna_mut <- length(intersect(cna, mut))
        gex_cna_mut <- length(intersect(intersect(gex, cna), mut))
        overmat[mult, ] <- c(length(gex), length(cna), length(mut), gex_cna, 
            gex_mut, cna_mut, gex_cna_mut)
    }

    # Return the sample N count matrix and the overlap sample matrix
    list(Samples = assaymat, Overlap = overmat)
}

#' Create a summary table of key characteristics for each study
#'
#' @param maes A list of MAE objects or a character vector with study short ids
#' 
#' @return
#' A table with study names, references, sample counts, data source, and 
#' other notes.
#'
#' @examples
#' studies <- getPCaStudies(uniqs = TRUE)
#' tab <- getPCaSummaryStudies(studies)
#'
#' @export getPCaSummaryStudies
getPCaSummaryStudies <- function(maes) {
    if (inherits(maes, "list")) {
        # Check that all list objects are of class MultiAssayExperiment
        if (!all(unlist(
            lapply(maes, FUN=\(x){ inherits(x, "MultiAssayExperiment") }
        )))){
            stop("List should consist only of 
                MAE-objects from the curatedPCaData-package")
        }
        # Check that list naming is ok and format it if necessary
        if (is.null(names(maes)) | length(names(maes)) < length(maes)){
            # If naming vector is not provided, extract it from MAE-objects
            names(maes) <- 
                base::tolower(unlist(lapply(maes, FUN=\(x){ 
                    # Extract study names from the first word in study_name
                    strsplit(
                        MultiAssayExperiment::colData(x)$study_name, 
                    ",| ")[[1]][1] 
                })))
        }
    # Character vector of study names, will use 'getPCa' to fetch MAEs
    } else if (inherits(maes, "character")) {
        maenames <- maes
        maes <- lapply(maenames, FUN = \(id) {
            curatedPCaData::getPCa(id)
        })
        names(maes) <- maenames
    } else {
        stop("Parameter 'maes' should either be a study short id character 
            vector or preferably a named list of MAE objects")
    }
    studies <- matrix("", nrow = length(maes), ncol = 6)
    colnames(studies) <- c("Study short id", "Sample types", 
        "GEX/CNA/MUT platform(s)", "Notes", "Data source", "Reference(s)")
    studies[, 1] <- names(maes)
    # Reformat names with special cases for abbreviations vs. names
    for (index in seq_len(length(maes))) {
        mae <- names(maes)[index]
        samptypes <- table(MultiAssayExperiment::colData(
            maes[[index]])$sample_type)
        sampnames <- names(samptypes)
        samplecollapse <- paste(paste(sampnames, samptypes, sep = ": "), 
            collapse = ", ")
        studies[index, "Sample types"] <- samplecollapse
        # Annotate additional useful information and append to correct
        # positions
        if (mae %in% c("abida", "mae_abida")) {
            studies[index, "Data source"] <- "cBioPortal"
            studies[index, "Reference(s)"] <- "Abida et al."
        } else if (mae %in% c("baca", "mae_baca")) {
            studies[index, "Data source"] <- "cBioPortal"
            studies[index, "Reference(s)"] <- "Baca et al."
        } else if (mae %in% c("barbieri", "mae_barbieri")) {
            studies[index, "Data source"] <- "cBioPortal"
            studies[index, "Reference(s)"] <- "Barbieri et al."
        } else if (mae %in% c("barwick", "mae_barwick")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "Custom DASL"
            studies[index, "Reference(s)"] <- "Barwick et al."
        } else if (mae %in% c("chandran", "mae_chandran", "yu")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "GPL8300 [HG_U95Av2]"
            studies[index, "Reference(s)"] <- "Chandran et al., Yu et al."
        } else if (mae %in% c("friedrich", "mae_friedrich")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "Custom Agilent array"
            studies[index, "Reference(s)"] <- "Friedrich et al."
        } else if (mae %in% c("hieronymus", "mae_hieronymus")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- 
                "GPL8737 Agilent-021529 Human CGH"
            studies[index, "Notes"] <- "CNA only"
            studies[index, "Reference(s)"] <- "Hieronymus et al."
        } else if (mae %in% c("icgcca", "mae_icgcca", "icgc-ca", "zhang")) {
            studies[index, "Data source"] <- "ICGC Data Portal (PRAD-CA)"
            studies[index, "Notes"] <- 
                "Canadian data from International Cancer Genome Collaboratory"
            studies[index, "Reference(s)"] <- "PRAD-CA in Zhang et al."
        } else if (mae %in% c("igc", "mae_igc")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- 
                "GPL570 [HG-U133_Plus_2]"
            studies[index, "Reference(s)"] <- "GEO accession code GSE2109"
        } else if (mae %in% c("kim", "mae_kim")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "GPL5188 [HuEx-1_0-st]"
            studies[index, "Reference(s)"] <- "Kim et al."
        } else if (mae %in% c("kunderfranco", "mae_kunderfranco", 
            "peraldo-neia", "longoni")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- 
                "GPL887 Agilent-012097 Human 1A Microarray (V2)"
            studies[index, "Reference(s)"] <- 
                "Kunderfranco et al., Peraldo-Neia et al., Longoni et al."
        } else if (mae %in% c("ren", "mae_ren")) {
            studies[index, "Data source"] <- "cBioPortal"
            studies[index, "Reference(s)"] <- "Ren et al."
        } else if (mae %in% c("sun", "mae_sun")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "GPL96 [HG-U133A]"
            studies[index, "Reference(s)"] <- "Sun et al."
        } else if (mae %in% c("taylor", "mae_taylor", "mskcc")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "Notes"] <- "Also known as MSKCC"
            studies[index, "GEX/CNA/MUT platform(s)"] <- 
                "GEX: GPL5188 [HuEx-1_0-st], CNA: GPL4091 Agilent CGH"
            studies[index, "Reference(s)"] <- "Taylor et al."
        } else if (mae %in% c("tcga", "mae_tcga")) {
            studies[index, "Data source"] <- "Xenabrowser"
            studies[index, "Reference(s)"] <- 
                "Cancer Genome Atlas Research Network, Goldman et al."
        } else if (mae %in% c("true", "mae_true")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- 
                "GPL3834 FHCRC Human Prostate PEDB cDNA v3 / v4"
            studies[index, "Reference(s)"] <- "True et al."
        } else if (mae %in% c("wallace", "mae_wallace")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "GPL571 [HG-U133A_2]"
            studies[index, "Reference(s)"] <- "Wallace et al."
        } else if (mae %in% c("wang", "mae_wang")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "GPL96 [HG-U133A]"
            studies[index, "Reference(s)"] <- "Wang et al., Jia et al."
        } else if (mae %in% c("weiner", "mae_weiner")) {
            studies[index, "Data source"] <- "GEO"
            studies[index, "GEX/CNA/MUT platform(s)"] <- "GPL5175 [HuEx-1_0-st]"
            studies[index, "Reference(s)"] <- "Weiner et al."
        }
    }
    studies
}

#' Create a vector of unique study identifiers available in curatedPCaData
#'
#' This function accesses the metadata available together with the 
#' curatedPCaData package and creates a vector of unique study identifier names 
#' available in the ExperimentHub resources. This vector is useful, for example,
#' when applying the 'getPCa' to create MAE from the studies.
#'
#' @param uniqs Should only unique instances be returned; by default TRUE
#'
#' @return A character vector with short study identifiers, e.g. 'abida', 
#' 'baca', ...
#'
#' @details Uses the internal 'metadata.csv' file, which is also used to provide
#' the metadata
#' available in ExperimentHub. 
#'
#' @examples
#' studyids <- getPCaStudies()
#'
#' @export getPCaStudies
getPCaStudies <- function(uniqs = TRUE) {
    assays_file <- system.file("extdata", "metadata.csv",
        package = "curatedPCaData", mustWork = TRUE)
    assay_metadat <- read.csv(assays_file, stringsAsFactors = FALSE)
    titles <- unlist(lapply(assay_metadat$Title, FUN = \(x) {
        strsplit(x, "_")[[1]][1]
    }))
    if (uniqs) {
        unique(titles)
    } else {
        titles
    }
}

#' curatedPCaData
#'
#' The package curatedPCaData offers a selection of annotated
#' prostate cancer datasets featuring multiple omics, manually
#' curated metadata, and derived downstream variables. The studies
#' are offered as MultiAssayExperiment (MAE) objects via ExperimentHub,
#' and comprise of clinical characteristics tied to gene expression,
#' copy number alteration and somatic mutation data. Further, downstream
#' features computed from these multi-omics data are offered. Multiple
#' vignettes help grasp characteristics of the various studies and provide
#' example exploratory and meta-analysis of leveraging the multiple
#' studies provided here-in.
#'
#' @docType package
#' @name curatedPCaData
#' @keywords internal
#' @import S4Vectors
#' @import MultiAssayExperiment
#' @import RaggedExperiment
#' @import ExperimentHub
#' @import reshape2
#' @importFrom methods slot is
#' @importFrom utils read.table data read.csv
#' @importFrom rlang .data
#' @importFrom stats median
#' @importFrom AnnotationHub query
"_PACKAGE"

# The following block is used by usethis to automatically manage roxygen
# namespace tags. Modify with care!  usethis namespace: start usethis
# namespace: end
NULL

###
#
# getPCa:
# Main function and additional support functions
# for fetching Prostate Cancer (PCa)
# datasets from ExperimentHub curated via curatedPCaData
#
###

## Functions adjusted from curatedTCGAData package on Bioconductor
## https://bioconductor.org/packages/release/data/experiment/html/curatedTCGAData.html

.conditionToIndex <- function(startVec, testVec, FUN) {
    logmat <- vapply(startVec, FUN, logical(length(testVec)))
    apply(logmat, 1L, any)
}

.getResources <- function(ExperimentHub, resTable, verbose) {
    fileNames <- stats::setNames(resTable[["RDataPath"]], resTable[["Title"]])
    resources <- lapply(resTable[["Title"]], function(res) {
    if (verbose) {
        message("Working on: ", gsub("\\.rds", "", basename(res)))
    }
    AnnotationHub::query(ExperimentHub, res)[[1L]]
    })

    names(resources) <- resTable[["Title"]]
    resources
}

.test_eh <- function(...) {
    tryCatch(
    {
        ExperimentHub(...)
    },
    error = function(e) {
        emsg <- conditionMessage(e)
        if (grepl("Timeout", emsg)) {
            warning("[experimenthub.bioconductor.org] timeout, localHub=TRUE",
            call. = FALSE
        )}
        ExperimentHub(..., localHub = TRUE)
    })
}

#' Construct Prostate Cancer MultiAssayExperiment object from specific cohort
#'
#' @description curatedPCaData provides \linkS4class{MultiAssayExperiment}
#' container objects that are constructed from ExperimentHub.
#' User provides PCa dataset name (see list on the overview-vignette or 
#' help files).
#'
#' @details This function will check against available resources in
#' ExperimentHub.
#' For a list of datasets, see the overview-vignette or below dataset listing.
#'
#' @param dataset character() of PCa cancer cohort names
#'     (e.g., 'abida')
#'
#' @param assays character() A vector of PCa assays. If not included, 
#' returns all available for the selected dataset; see below for more details.
#'
#' @param timestamp character(1) "20230215" indicating the data version to 
#' obtain from `ExperimentHub`. See `timestamp` section details.
#'
#' @param sampletypes A character vector of sample types to include in the MAE.
#' If the parameter is missing, then all samples are returned. Allowed values
#' are: 'primary', 'metastatic', 'normal', 'BPH', 'atrophic'
#'
#' @param ... Additional arguments passed on to the
#'     \code{\link[ExperimentHub:ExperimentHub-class]{ExperimentHub}}
#'     constructor
#'
#' @param verbose logical(1) Whether to show the dataset currenlty being
#'     (down)loaded (default TRUE)
#'
#' @section Available datasets:
#'
#' Following shortnames can be used with getPCa to query for their omics from
#' ExperimentHub. For more detailed description of the studies, see their
#' corresponding R documentation file. Further details are reported in the 
#' overview-vignette.
#'
#' \preformatted{
#'
#' Shortname      Rd documentation file           Longer name(s)
#' ----------------------------------------------------------------------------
#'
#' abida        curatedPCaDatasets_abida        Abida et al.
#' baca         curatedPCaDatasets_baca         Baca et al.
#' barbieri     curatedPCaDatasets_barbieri     Barbieri et al.
#' barwick      curatedPCaDatasets_barwick      Barwick et al.
#' chandran     curatedPCaDatasets_chandran     Chandran et al., Yu et al.
#' friedrich    curatedPCaDatasets_friedrich    Friedrich et al.
#' hieronymus   curatedPCaDatasets_hieronymus   Hieronymus et al.
#' icgcca       curatedPCaDatasets_icgcca       ICGC Canadian subset
#' igc          curatedPCaDatasets_igc          International Genomics Consortium (PCa subset)
#' kim          curatedPCaDatasets_kim          Kim et al.
#' kunderfranco curatedPCaDatasets_kunderfranco Kunderfranco et al.
#' ren          curatedPCaDatasets_ren          Ren et al.
#' sun          curatedPCaDatasets_sun          Sun et al.
#' taylor       curatedPCaDatasets_taylor       Taylor et al.
#' tcga         curatedPCaDatasets_tcga         The Cancer Genome Atlas (PCa subset, PRAD-prefix)
#' true         curatedPCaDatasets_true         True et al.
#' wallace      curatedPCaDatasets_wallace      Wallace et al.
#' wang         curatedPCaDatasets_wang         Wang et al.
#' weiner       curatedPCaDatasets_weiner       Weiner et al.
#' }
#'
#' @section Available Assays:
#'
#' The list of ExperimentList assay names and their descriptions.
#' These assays can be entered as part of the \code{assays} argument in the
#' main function.
#' \preformatted{
#'
#' ExperimentList data types   Description
#' ----------------------------------------------------------------------------
#'
#' gex.rma            Gene expression values (RMA normalized)
#' gex.logq                                  (Log-quantile)
#' gex.relz                                  (Relative z-scores)
#' gex.logr                                  (Log-ratios)
#' gex.rsem.log                              (Log-RSEM)
#' cna.gistic         Copy number alteration (GISTIC calls)
#' cna.logr                                  (Log-ratios)
#' mut                Somatic mutation calls
#' cibersort          Immune deconvolution as estimated by CIBERSORTx
#' xcell                                                   xCell
#' epic                                                    EPIC
#' quantiseq                                               quanTIseq
#' mcp                                                     MCP-counter
#' estimate                                                ESTIMATE
#' scores             Various risk and AR scores; see vignette references.
#' }
#'
#' @section timestamp: "20230215"
#' The timestamp is updated in case the data is updated. In this case, this
#' section describes the changes made for new timestamps. At this time, the
#' only data deposit is from 2023, Feb 15th, indicated by "20230215".
#'
#' @seealso curatedPCaData-package
#'
#' @return a \linkS4class{MultiAssayExperiment} of the specified assays and
#' cancer cohort
#'
#' @examples
#' mae_taylor <- getPCa(
#'     dataset = "taylor", timestamp = "20230215"
#' )
#'
#' @importFrom utils read.csv
#' @importFrom AnnotationHub query
#' @export getPCa
getPCa <- function(
    # Dataset name
    dataset,
    # Names for the set of assay data objects to extract from the MAE object's 
    # whole available subset in ExperimentList
    assays,
    # Timestamps of data from ExperimentHub; allowed values: '20230215'
    timestamp,
    # If not missing, subsetting the MAE object to certain sample types
    sampletypes,
    # Verbosity
    verbose = FALSE,
    # Additional parameters
    ...) {
    if (missing(dataset)) {
        stop("Select dataset; see ?curatedPCaData")
    }
    if (length(dataset) > 1) {
        stop("Select only one dataset at a time.")
    }
    dataset <- tolower(dataset) # datasets are saved as lower case
    # Change this if new update (with new timestamp) is added
    if (missing(timestamp)) {
        timestamp <- "20230215"
    }
    # Update this if more timestamps becomes available
    if (any(!timestamp %in% c("20230215"))) {
        stop("'timestamp' contains a timestamp that is not '20230215'; see 
        '?curatedPCaData'")
    }
    assays_file <- system.file("extdata", "metadata.csv", 
        package = "curatedPCaData", mustWork = TRUE)
    assay_metadat <- read.csv(assays_file, stringsAsFactors = FALSE)
    # Separate names Title in assay_metadat to get dataset, assay and timestamp 
    # separately
    eh_assays <- assay_metadat[["Title"]]
    eh_assays_sep <- t(as.data.frame(strsplit(eh_assays, "_")))
    # Get only requested dataset
    dataId <- which(eh_assays_sep[, 1] == dataset)
    if (length(dataId) == 0) {
        stop("Dataset name is incorrect or not available.")
    }
    eh_assays_sep <- eh_assays_sep[dataId, ]
    # Get available assays for selected dataset
    assaysAvail <- unique(eh_assays_sep[, 2]) 
    # Select user specified assays
    if (!missing(assays)) { # If nothing specific requested, return all
    # If user asks for something that is not available,
    if (any(!assays %in% assaysAvail)) { 
        stop(paste0(c("At least one of asked assay names is not available. 
            The available assays for this dataset are:", assaysAvail), 
                collapse = "  "))
    } else { # Select only requested assays
        assaysAvail <- unique(c(assays, "colData", "sampleMap"))
    }
    }
    # Select assays by timestamp request. If more versions are added this has 
    # to be updated. sampleMap is always selected by the latest timestamp given.
    # If not available, latest is used.
    codeAssay <- c()
    latest <- as.character(max(as.numeric(timestamp)))
    for (i in assaysAvail) {
        assayId <- which(eh_assays_sep[, 2] == i)
        availableTimestamp <- eh_assays_sep[assayId, 3]
        # Use latest given timestamp for sampleMap, if not available, use latest
    if (i == "sampleMap") { 
        if (latest %in% availableTimestamp) {
            selectedTimestamp <- latest
        } else {
            selectedTimestamp <- as.character(max(as.numeric(availableTimestamp)
                ))
        }
    } else {
        # Go through the user given timestamp request and get the first match, 
        # if no match, give latest
        nomatch <- FALSE
        n <- 1
        while (!nomatch) {
            # Select the first match, if no match, select latest
            if (timestamp[n] %in% availableTimestamp) {
                nomatch <- TRUE
                selectedTimestamp <- timestamp[n]
            } else {
                n <- n + 1
                if (n > length(timestamp)) {
                nomatch <- TRUE
                selectedTimestamp <- 
                    as.character(max(as.numeric(availableTimestamp)))
                }
            }
        }
    }
    codeAssay <- c(codeAssay, paste0(dataset, "_", i, "_", selectedTimestamp))
    }
    # Get indices of selected dataset_assay_timestamp combos
    fileIdx <- .conditionToIndex(codeAssay, eh_assays, function(x) startsWith(
        eh_assays, x))
    fileMatches <- assay_metadat[fileIdx, c("Title", "DispatchClass")]
    # Sanitycheck
    if (!length(nrow(fileMatches))) {
        stop("Cancer and data type combination(s) not available")
    }
    eh <- .test_eh()
    # Get the data
    assay_list <- .getResources(
        eh, assay_metadat[fileIdx, c("Title", "RDataPath")], verbose
    )
    # Get experiments and name them only by the assay/experiment/etc name
    # Omit colData and sampleMap since they are added separately
    cD_idx <- which(grepl("colData", names(assay_list), fixed = TRUE))
    sM_idx <- which(grepl("sampleMap", names(assay_list), fixed = TRUE))
    # Final sanity check
    if (length(cD_idx) != 1 | length(sM_idx) != 1) {
        stop("Either colData or sampleMap is missing for this dataset and the 
        MAE cannot be constructed, or there are multiple with same timestamp.")
    }
    eh_experiments <- ExperimentList(assay_list[-c(cD_idx, sM_idx)])
    names(eh_experiments) <- gsub("(^[a-z]*)_(.*)_(.*)", "\\2", names(
        eh_experiments))
    # Inform user
    message("Constructing the MultiAssayExperiment object from retrieved 
        components.")
    # Return MAE; if parameter 'sampletypes' is not missing, subsetting
    mae <- MultiAssayExperiment::MultiAssayExperiment(
        experiments = eh_experiments,
        colData = assay_list[cD_idx][[1]],
        sampleMap = assay_list[sM_idx][[1]]
    )
    # Return full MAE
    if(missing(sampletypes)){
        mae
    # Return a MAE with a subset to certain sample_types
    }else{
        MultiAssayExperiment::subsetByColData(mae, mae$sample_type %in% 
            sampletypes)
    }
}

library(hexSticker)
library(magick)

# image from : https://icon-icons.com/icon/tumor-cancer-human-biology-disease-medical-health-cell/133488
imgurl <- "man/figures/tumor.png"

sticker(imgurl, 
        package="curatedPCaData", p_size=5, p_color = "#FB62AC", p_y = 0.6,
        s_x=1, s_y=1.2, s_width=.6,
        h_fill = "white", h_color = "#2B2671",
        url = "https://github.com/Syksy/curatedPCaData", u_color = "#FB62AC", u_size = 1,
        filename="man/figures/hex.png")

###
#
# Native 'R CMD check' tests run on the 'curatedPCaData'-package
# Any exceptions will count as a failure for 'R CMD check' run (notably, does 
# not require 'RUnit' or 'testthat' packages for testing)
#
###

##
# Testing of getPCa main functionality
##

# Test retrieval of TCGA with all assays
# Get default fetching of a MAE object based on short id
methods::is(curatedPCaData::getPCa("tcga"), "MultiAssayExperiment")

# Test retrieval of Taylor with a pre-specified subset of assays
# Get fetching of an assay subset
methods::is(curatedPCaData::getPCa("taylor", assays = c("gex.rma", "cibersort", 
    "scores")), "MultiAssayExperiment")

# Test a data fetch that should result in an error
# Test that an error is produced correctly for a study that does not exist
methods::is(try({curatedPCaData::getPCa("studyname_misspelled", assays = 
    c("foo", "bar"))}, silent=TRUE), "try-error")

# Test fetching of an assay that does not exist
# Test that an error is produced correctly for assays that do not exist
methods::is(try({curatedPCaData::getPCa("tcga", assays = "typo")}, 
    silent=TRUE), "try-error")

# Test sample subtype subsetting during getPCa
# Get only primary samples from TCGA
all(curatedPCaData::getPCa("tcga", sampletypes = "primary")$sample_type == 
    "primary")
# Test omitting metastatic samples from Chandran et al.
all(curatedPCaData::getPCa("chandran", sampletypes = c("primary", "normal")
    )$sample_type %in% c("primary", "normal"))

##
# Testing of supporting summary functions etc
##

# Test fetching of study short ids and that the 19 studies originally available 
# in Laajala et al. 2013 are retrieved correctly
# Tested function: curatedPCaData::getPCaStudies
studies <- curatedPCaData::getPCaStudies()
all(c("abida", "baca", "barbieri", "barwick", "chandran", "friedrich", 
    "hieronymus", "icgcca", "igc", "kim", "kunderfranco", "ren", "sun", 
    "taylor", "tcga", "true", "wallace", "wang", "weiner") %in% studies)

# Fetch MAE objects for further use
maes <- lapply(studies, FUN=\(id) { curatedPCaData::getPCa(id) })
names(maes) <- studies

# getPCaSummaryTable should summarize into a character matrix key instances and 
# percentages for certain values for a given colData metadata variable
# Tested function: curatedPCaData::getPCaSummaryTable
inherits(curatedPCaData::getPCaSummaryTable(maes, var.name = "grade_group", 
    vals=c("<=6", "3+4", "4+3", "7", ">=8")), "matrix")

# getPCaSummaryTable should summarize into a character matrix event counts and 
# follow-up times for a Surv-like data
# Tested function: curatedPCaData::getPCaSummarySurv
inherits(curatedPCaData::getPCaSummarySurv(maes, event.name = 
    "disease_specific_recurrence_status", 
    time.name = "days_to_disease_specific_recurrence"), "matrix")

# getPCaSummarySamples should return a list of length 2; first element 
# containing unique assay names and N counts in each study, and second element 
# a matrix with GEX/CNA/MUT combinations for overlap
# Tested function: curatedPCaData::getPCaSummarySamples
inherits(curatedPCaData::getPCaSummarySamples(maes), "list")
length(curatedPCaData::getPCaSummarySamples(maes)) == 2

# getPCaSummaryStudies should create a verbose character matrix depicting key 
# characteristics for each study, such as sample counts, platforms, and special 
# notes to be aware of
# Tested function: curatedPCaData::getPCaSummaryStudies, 
# curatedPCaData::getPCaStudies
inherits(curatedPCaData::getPCaSummaryStudies(maes), "matrix")

## Steps involved in making the curatedPCaData ExperimentHub-objects

## From the package root:

# ../data-raw/download-clinical.R
## -> Downloads the clinical data matrices from multiple sources (GEO, cBioPortal, cgdsr, ...)
##   and combines them into colData-suitable data.frames for MultiAssayExperiments.

# ../data-raw/download-data.R
## -> Download and harmonize raw data; for example, for gene expression CEL data this will call the 
##    correct functions for using GEOquery, and subsequent data processing such as RMA-normalization.

# ../data-raw/data-curatedPCaData_genes.R
## -> Extract hugo symbols from biomaRt, as well as specific array annotations if available.
##    These are used when constructing e.g. gene-level expression matrices.

# At this stage, the version 1 of curatedPCaData should be build using R CMD build.
# The correct MAE-objects have been stored and in prior versions were offered as LazyLoad'ed MAE-objects.
# After this, derived variables are extracted

# ../data-raw/derive-variables.R
## -> This script assumes the correct MAE-objects are stored inside ../data/-folder of the package.
##    The MAE-objects are loaded from there, and then the derived variables (such as immune deconvolution
##    results and risk scores) are calculated and appended as slots/assays into the existing MAE-objects.

# After above steps, original MultiAssayExperiments were stored in ../data/ of the package.
# In order to make the package compatible with ExperimentHub, these MAE-objects were dissected and an
# additional metadata sheet is automatically generated:

# write.csv(curatedPCaData:::export_metadata(timestamp = "20230215"), file="metadata.csv", quote=TRUE, row.names=FALSE)
## -> Creates the ExperimentHub-friendly metadata.csv

## The R code and functions required for running above data curation scripts are located under the folder:
# .../data-raw/R/*.R

## Note that these require an extensive amount of dependencies, which have been omitted from curatedPCaData to avoid bloat.

## Steps involved in creating the metadata.csv provided for ExperimentHub

## The code for generating metadata.csv for ExperimentHub are based on the MAE-objects previously present in curatedPCaData; the function call for generating this is:
## Located in 'curatedPCaData/R/exportfuncs.R'
## Example export with time stamp for 2023, February 15th (this requires curatedPCaData v1.*, with LazyLoad on for MAE-objects):
write.csv(curatedPCaData:::export_metadata(timestamp = "20230215"), file="metadata.csv", quote=TRUE, row.names=FALSE)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE,
    cache = TRUE,
    tidy = TRUE,
    width.cutoff = 70
)

## ----message=FALSE------------------------------------------------------------
library(curatedPCaData)

# Use a function to extract all known study short identifiers
studies <- curatedPCaData::getPCaStudies()
studies

# List apply across studies to extract all MAE objects corresponding to the 
# short identifiers
maes <- lapply(studies, FUN=\(id) { curatedPCaData::getPCa(id) })
names(maes) <- studies

## ----studies1, message = FALSE------------------------------------------------
# Create a summary table depicting key features in available studies
studytable <- curatedPCaData::getPCaSummaryStudies(maes)

## ----studies2, results = 'asis', echo=FALSE-----------------------------------
knitr::kable(studytable, caption = "Key study characteristics")

## ----template, results='asis', echo=FALSE-------------------------------------
data(template_prad)
template <- template_prad
# Add spaces to |-dividers for linechanges
template <- do.call("cbind", lapply(template, FUN = function(x) {
    gsub("|", " | ", x, fixed = TRUE)
}))
knitr::kable(template, caption = "Template for prostate adenocarcinoma clinical 
metadata")

## ----gleasons1----------------------------------------------------------------
# Create a summary table of Gleason grades
gleasons <- curatedPCaData::getPCaSummaryTable(
    maes, 
    var.name = "gleason_grade", 
    vals=5:10
)

## ----gleasons2, results = 'asis', echo=FALSE----------------------------------
knitr::kable(gleasons, caption = "Gleason grades across datasets in 
curatedPCaData")

## ----groups1------------------------------------------------------------------
# Create a summary table of grade groups
gradegroups <- curatedPCaData::getPCaSummaryTable(
    maes, 
    var.name = "grade_group", 
    vals=c("<=6", "3+4", "4+3", "7", ">=8")
)

## ----groups2, results = 'asis', echo=FALSE------------------------------------
knitr::kable(gradegroups, caption = "Grade groups across datasets in 
curatedPCaData")

## ----recurrences1-------------------------------------------------------------
# Create a summary table of biochemical recurrences
recurrences <- curatedPCaData::getPCaSummarySurv(
    maes, 
    event.name = "disease_specific_recurrence_status", 
    time.name = "days_to_disease_specific_recurrence"
)

## ----recurrences2, results = 'asis', echo=FALSE-------------------------------
knitr::kable(recurrences, caption = "Disease recurrence end point across 
datasets in curatedPCaData")

## ----os1----------------------------------------------------------------------
# Create a summary table of overall survival
survivals <- curatedPCaData::getPCaSummarySurv(
    maes, 
    event.name = "overall_survival_status", 
    time.name = "days_to_overall_survival"
)

## ----os2, results = 'asis', echo=FALSE----------------------------------------
knitr::kable(survivals, caption = "Overall survival end point across datasets 
in curatedPCaData")

## ----tcgaex-------------------------------------------------------------------
tcga_subset <- getPCa(
    dataset = "tcga", 
    assays = c("gex.rsem.log", "xcell", "scores"), 
    timestamp = "20230215"
)

tcga_subset

## ----ehquery------------------------------------------------------------------
mae_tcga <- getPCa("tcga")
mae_taylor <- getPCa("taylor")

## ----access-------------------------------------------------------------------
mae_taylor[["gex.rma"]][1:5, 1:5]

## ----clinical-----------------------------------------------------------------
MultiAssayExperiment::colData(mae_tcga)[1:2, ]

## ----metadat------------------------------------------------------------------
metadata <- read.csv(system.file("extdata", "metadata.csv", package = 
    "curatedPCaData"))
head(metadata)

## ----samplecountsoverlap------------------------------------------------------
# Retrieve samples counts across different unique assay names as well as omics 
# overlap sample counts
samplecounts <- curatedPCaData::getPCaSummarySamples(maes)

## ----samplecounts, results='asis', echo=FALSE---------------------------------
knitr::kable(samplecounts$Samples, caption = "Sample N counts in each omics for 
every MAE object")

## ----sampleoverlap, results='asis', echo=FALSE--------------------------------
knitr::kable(samplecounts$Overlap, caption = "Sample N counts for intersections 
between different omics")

## -----------------------------------------------------------------------------
mae_taylor

## -----------------------------------------------------------------------------
head(mae_taylor[["cibersort"]])[1:5, 1:3]

## -----------------------------------------------------------------------------
head(mae_taylor[["quantiseq"]])[1:5, 1:3]
head(mae_taylor[["xcell"]])[1:5, 1:3]
head(mae_taylor[["epic"]])[1:5, 1:3]
head(mae_taylor[["mcp"]])[1:5, 1:3]

## ----scores-------------------------------------------------------------------
mae_tcga[["scores"]][, 1:4]

## -----------------------------------------------------------------------------
taylor <- getPCa("taylor", 
    assays = c("gex.rma", "cna.gistic"),
    sampletypes = "primary"
)

class(taylor) 

taylor

## -----------------------------------------------------------------------------
library(survival)
# BCR events
taylor_bcr <- colData(taylor)$disease_specific_recurrence_status
# BCR events / censoring follow-up time
taylor_fu <- colData(taylor)$days_to_disease_specific_recurrence

taylor_surv <- Surv(event = taylor_bcr, time = taylor_fu)

class(taylor_surv)

head(taylor_surv)


## -----------------------------------------------------------------------------
library(survminer)

taylor_bcr_gleason <- data.frame(bcr = taylor_surv, 
    gleason = colData(taylor)$gleason_grade)

fit <- survfit(bcr ~ gleason, data = taylor_bcr_gleason)
ggsurvplot(fit, 
    data = taylor_bcr_gleason, 
    ylab = "Biochemical recurrence free proportion",
    risk.table = TRUE,
    size = 1,
    pval = TRUE,
    ggtheme = theme_bw()
    )

## -----------------------------------------------------------------------------
taylor_coxdat <- MultiAssayExperiment::wideFormat(taylor["PTEN",,],
    colDataCols = c("age_at_initial_diagnosis", "gleason_grade",
    "disease_specific_recurrence_status", 
    "days_to_disease_specific_recurrence"))

taylor_coxdat <- as.data.frame(taylor_coxdat)

taylor_coxdat$y <- Surv(
    time = taylor_coxdat$days_to_disease_specific_recurrence,
    event = taylor_coxdat$disease_specific_recurrence_status)
    
head(taylor_coxdat)    

## -----------------------------------------------------------------------------
coxmodel <- coxph(y ~ cna.gistic_PTEN + gex.rma_PTEN + gleason_grade, 
    data = taylor_coxdat)
coxmodel

## ----session------------------------------------------------------------------
sessionInfo()

#' Template for curatedPCaData clinical fields
#'
#' This data frame contains the clinical fields which were
#' the aim for extraction when gathering metadata for each dataset.
#' Variable types, ranges, and description is reported.
#'
#' @return A data.frame of the PCa template
#'
#' @docType data
#' @examples
#' data(template_prad)
#' head(template_prad)
"template_prad"

#' Abida et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex), copy
#' number alteration (cna), mutations (mut) and immune cell estimates for Abida 
#' et al.
#'
#' @format A MAE object spanning 444 castrate resistant prostate cancer samples.
#' \describe{
#'     \item{cna.gistic}{matrix with 20291 rows and 444 columns, from GISTIC 
#'         discretized copy number alteration calls.}
#'     \item{gex.relz}{matrix with 18971 rows and 266 columns, from z-score 
#'         normalized expression in relative to paired normals.}
#'     \item{mut}{RaggedExperiment with 63184 rows and 444 columns, mutation 
#'         data from cbioportal}
#'     \item{cibersort}{matrix with 22 rows and 261 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 261 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 261 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 261 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 261 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 261 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{mmatrix with 11 rows and 261 columns, of mcp-counter based 
#'         deconvolution data}
#'
#' }
#' @details the clinical data refers to a sample of 444 tumors collected in 429 
#' patients. The tissue was collected primarily at metastatic sites rather than 
#' from the prostate.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/31061129/}{PubMed})
#' @source  \url{https://www.cbioportal.org/study/summary?id=prad_su2c_2019}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_abida
#' @examples
#' mae_abida <- getPCa('abida')
#' @name curatedPCaDatasets_abida
#' @keywords datasets
NULL

#' Baca et al. MAE-object
#'
#' MultiAssayExperiment object containing copy number alteration (cna) and 
#' mutations for Baca et al.
#'
#' @format A MAE object spanning 56 prostate cancer samples.
#' \describe{
#'     \item{cna.gistic}{matrix with 20124 rows and 56 columns, from GISTIC 
#'         discretized copy number alteration calls.}
#'     \item{mut}{RaggedExperiment with 2734 rows and 57 columns, mutation data 
#'         from cbioportal}
#' }
#' @source \url{https://www.cbioportal.org/study/summary?id=prad_broad_2013}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_baca
#' @docType data
#' @examples
#' mae_baca <- getPCa('baca')
#' @name curatedPCaDatasets_baca
#' @keywords datasets
NULL

#' Barbieri et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex), copy
#' number alteration (cna), mutations (mut) and immune cell estimates for 
#' Barbieri et al.
#'
#' @format A MAE object spanning prostate adenocarcinomas from Barbieri et. al
#' \describe{
#'     \item{cna.gistic}{matrix with 20844 rows and 109 columns, from GISTIC 
#'         discretized copy number alteration calls}
#'     \item{gex.relz}{matrix with 17917 rows and 31 columns, from z-score 
#'         normalized expression in relative to paired normals.}
#'     \item{mut}{RaggedExperiment with 5737 rows and 112 columns, mutation 
#'         data from cbioportal}
#'     \item{cibersort}{matrix with 22 rows and 31 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 31 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 31 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 31 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 31 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 31 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 31 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details The data comprises of primary localised prostate tumors from two 
#' cohorts, the Weill Cornell Medical College (WCMC; New York, NY), and the 
#' Uropath (Perth, Australia), which commercially provides banked urological 
#' tissues. None of the samples comes from patients who had received prior 
#' treatment for prostate cancer.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/22610119/}{PubMed})
#' @source \url{https://www.cbioportal.org/study/summary?id=prad_broad}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_barbieri
#' @examples
#' mae_barbieri <- getPCa('barbieri')
#' @name curatedPCaDatasets_barbieri
#' @keywords datasets
NULL

#' Barwick et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates for Barwick et al.
#'
#' @format A MAE object spanning 146 prostate cancer samples.
#' \describe{
#'     \item{gex.logq}{matrix with 482 rows and 146 columns, for the 
#'         log-quantile normalized gene expression data}
#'     \item{cibersort}{matrix with 22 rows and 139 columns, of cibersort based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 139 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 139 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 3 rows and 139 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 4 rows and 139 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details Barwick et al. uses an older customized DASL array; therefore its 
#' gene coverage is lower, and many downstream methods fail due to lack of gene 
#' overlap.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/22610119/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE18655}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_barwick
#' @examples
#' mae_barwick <- getPCa('barwick')
#' @name curatedPCaDatasets_barwick
#' @keywords datasets
NULL

#' Chandran et al., Yu et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates for Chandran et al., Yu et al.
#'
#' @format An MAE object spanning 171 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 9007 rows and 171 columns, for the gene 
#'         expression data}
#'     \item{cibersort}{matrix with 22 rows and 171 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 171 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 171 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 171 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 171 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 171 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 171 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/17430594/}{PubMed}) 
#' (\href{https://pubmed.ncbi.nlm.nih.gov/15254046/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE6919}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_chandran
#' @examples
#' mae_chandran <- getPCa('chandran')
#' @name curatedPCaDatasets_chandran
#' @keywords datasets
NULL

#' Friedrich et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates for Friedrich et al.
#'
#' @format An MAE object spanning 255 men with prostate cancer
#' \describe{
#'     \item{gex.logq}{matrix with 23097 rows and 255 columns, for the 
#'         log-quantile normalized gene expression data}
#'     \item{cibersort}{matrix with 22 rows and 255 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 255 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 255 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 255 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 255 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 255 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 255 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details The data comprises of 255 samples, with 164 primary tumors samples, 
#' 52 adjacent normal samples, and 39 benign prostate hyperplasia samples.  
#' This dataset includes in its totality the 164 samples analysed in Kreutz 
#' et al. 2020.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/32365858/}{PubMed}) 
#' (\href{https://pubmed.ncbi.nlm.nih.gov/32631745/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE134051}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_friedrich
#' @examples
#' mae_friedrich <- getPCa('friedrich')
#' @name curatedPCaDatasets_friedrich
#' @keywords datasets
NULL

#' Hieronymus et al. MAE-object
#'
#' MultiAssayExperiment object containing copy number alteration (cna) for 
#' Hieronymus et al.
#'
#' @format A MAE object spanning 104 tumor samples
#' \describe{
#'     \item{cna.gistic}{matrix with 18026 rows and 104 columns, from GISTIC 
#'         discretized copy number alteration calls}
#' }
#' @details The data comprises of 104 samples, for which are available clinical 
#' data and Copy Number Alteration, but no gene expression data -- thus no 
#' deconvolution results are available.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/25024180/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE54691}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_hieronymus
#' @examples
#' mae_hieronymus <- getPCa('hieronymus')
#' @name curatedPCaDatasets_hieronymus
#' @keywords datasets
NULL

#' ICGC CA MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates for the ICGC CA (Canadian) cohort.
#'
#' @format An MAE object spanning 213 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 17208 rows and 213 columns, of gene expression
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 213 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 213 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 213 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 213 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 213 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 213 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 213 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details The data refers to samples from the ICGC Canadian Prostate Cancer 
#' Genome Network (ICGC-PRAD-CA)
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/28068672/}{PubMed})
#' @source \url{https://dcc.icgc.org/projects/PRAD-CA}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_icgcca
#' @examples
#' mae_icgcca <- getPCa('icgcca')
#' @name curatedPCaDatasets_icgcca
#' @keywords datasets
NULL

#' International Genomics Consortium (IGC) MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from IGC's Expression Project for Oncology (expO) with a subset for
#' prostate cancer
#'
#' @format An MAE object spanning 83 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 12798 rows and 83 columns, of gene expression 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 83 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 83 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 83 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 83 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 83 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 83 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 83 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#'
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=gse2109}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_igc
#' @examples
#' mae_igc <- getPCa('igc')
#' @name curatedPCaDatasets_igc
#' @keywords datasets
NULL

#' Kim et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from Kim et al.
#'
#' @format An MAE object spanning 266 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 17638 rows and 266 columns, of gene expression
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 266 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 266 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 266 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 266 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 266 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 2 rows and 266 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 266 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details The dataset consists of 266 NCCN very low/low or 
#' favorable-intermediate risk PCa patients
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/30542054/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE119616}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#* omics.
#'
#' @rdname curatedPCaDatasets_kim
#' @examples
#' mae_kim <- getPCa('kim')
#' @name curatedPCaDatasets_kim
#' @keywords datasets
NULL

#' Kunderfranco et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from Kunderfranco et al.
#'
#' @format An MAE object spanning 67 samples of normal prostate samples and 
#' prostate cancer samples
#' \describe{
#'     \item{gex.logr}{matrix with 16546 rows and 67 columns, of gene expression
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 67 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 67 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 67 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 67 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 67 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 2 rows and 67 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 67 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details The data contains 14 disease free benign prostate hyperplasia 
#' samples and 53 prostate cancer samples.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/20479932/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE14206}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_kunderfranco
#' @examples
#' mae_kunderfranco <- getPCa('kunderfranco')
#' @name curatedPCaDatasets_kunderfranco
#' @keywords datasets
NULL

#' Ren et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex), mutations and 
#' immune cell estimates from Ren et al.
#'
#' @format An MAE object spanning 65 men with prostate cancer
#' \describe{
#'     \item{gex.relz}{matrix with 21046 rows and 65 columns, of gene expression
#'         data}
#'     \item{mut}{RaggedExperiment with 50625 rows and 65 columns, of mutation 
#'         data from cbioportal}
#'     \item{cibersort}{matrix with 22 rows and 65 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 65 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 65 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 65 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 65 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 65 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 65 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details The data contains 14 disease free benign prostate hyperplasia 
#' samples and 53 prostate cancer samples.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/28927585/}{PubMed})
#' @source \url{https://www.cbioportal.org/study/summary?id=prad_eururol_2017}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_ren
#' @examples
#' mae_ren <- getPCa('ren')
#' @name curatedPCaDatasets_ren
#' @keywords datasets
NULL

#' Sun et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from Sun et al.
#'
#' @format An MAE object spanning 79 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 12798 rows and 79 columns, of gene expression 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 79 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 79 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 79 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 79 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 79 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 79 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 79 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#'
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/19343730/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE25136}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_sun
#' @examples
#' mae_sun <- getPCa('sun')
#' @name curatedPCaDatasets_sun
#' @keywords datasets
NULL

#' Taylor et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex), copy
#' number alteration (cna), mutations and immune cell estimates from Taylor et 
#' al.
#'
#' @format An MAE object spanning 218 men with prostate cancer
#' \describe{
#'     \item{cna.gistic}{matrix with 17832 rows and 194 columns, of gistic 
#'         values for copy number alteration data}
#'     \item{cna.logr}{matrix with 18062 rows and 218 columns, of log-ratios for
#'         copy number alteration data}
#'     \item{gex.rma}{matrix with 17410 rows and 179 columns, of gene expression
#'         data}
#'     \item{mut}{RaggedExperiment with 90 rows and 43 columns, of mutation 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 179 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 179 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 179 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 179 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 179 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 179 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 179 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#'
#' @details Note that there is lack of overlap between the omics provided for 
#' each sample.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/20579941/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE21035}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_taylor
#' @examples
#' mae_taylor <- getPCa('taylor')
#' @name curatedPCaDatasets_taylor
#' @keywords datasets
NULL

#' TCGA MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex), copy
#' number alteration (cna), mutations and immune cell estimates from GDC TCGA.
#'
#' @format An MAE object spanning 369 men with prostate cancer
#' \describe{
#'     \item{cna.gistic}{matrix with 23151 rows and 492 columns, from GISTIC 
#'         discretized copy number alteration calls}
#'     \item{gex.rsem.log}{matrix with 19658 rows and 461 columns, of gene 
#'         expression data}
#'     \item{mut}{RaggedExperiment with 30897 rows and 495 columns, of mutation 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 550 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 461 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 461 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 461 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{mcp}{matrix with 11 rows and 461 columns, of mcp-counter based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 461 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 416 columns, of risk scores and AR 
#'         scores}
#' }
#'
#' @details TCGA data was obtained from the latest GDC's XenaBrowser release.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/26544944/}{PubMed})
#' @source \url{https://xenabrowser.net/datapages/?cohort=GDC\%20TCGA\%20Prostate\%20Cancer\%20(PRAD)}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_tcga
#' @examples
#' mae_tcga <- getPCa('tcga')
#' @name curatedPCaDatasets_tcga
#' @keywords datasets
NULL

#' True et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from True et al.
#' @format An MAE object spanning 32 men with prostate cancer
#' \describe{
#'     \item{gex.logr}{matrix with 3615 rows and 32 columns, of gene expression 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 32 columns, of cibersort based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 32 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 32 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{mcp}{matrix with 7 rows and 32 columns, of mcp-counter based 
#'         deconvolution data}
#'     \item{scores}{matrix with 2 rows and 32 columns, of risk scores and AR 
#'         scores}
#'     \item{estimate}{data.frame with 4 rows and 32 columns, of cell types 
#'         based on ESTIMATE method}
#' }
#' @details The expression data for this dataset was produced by an older two 
#' colour chip that provides the relative expression levels for between tumor 
#' and normal.  Due to the chip type, there was a lack of gene overlap with 
#' some of the downstream methods, thus some downstream methods are missing.
# @references (\href{https://pubmed.ncbi.nlm.nih.gov/16829574/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE5132}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_true
#' @examples
#' mae_true <- getPCa('true')
#' @name curatedPCaDatasets_true
#' @keywords datasets
NULL

#' Wallace et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from Wallace et al.
#' @format An MAE object spanning 83 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 12783 rows and 89 columns, of gene expression 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 83 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 89 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 89 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 89 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 89 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 89 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 89 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#'
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/18245496/}{PubMed})
#'
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE6956}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_wallace
#' @examples
#' mae_wallace <- getPCa('wallace')
#' @name curatedPCaDatasets_wallace
#' @keywords datasets
NULL

#' Wang et al. MAE-object
#'
#' MultiAssayExperiment object containing gene expression (gex) and immune cell 
#' estimates from Wang et al.
#' @format An MAE object spanning 148 men with prostate cancer
#' \describe{
#'     \item{gex.rma}{matrix with 12798 rows and 148 columns, of gene expression
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 148 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 148 columns, of xcell based 
#'         deconvolution data}
#'     \item{epic}{matrix with 8 rows and 148 columns, of epic based 
#'         deconvolution data}
#'     \item{quantiseq}{matrix with 11 rows and 148 columns, of quantiseq based 
#'         deconvolution data}
#'     \item{estimate}{data.frame with 4 rows and 148 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 148 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 148 columns, of mcp-counter based 
#'         deconvolution data}
#' }
#' @details 148 prostate samples, with various amounts of tumor, stroma, BPH and
#' atrophic gland, were used for this study.
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/20663908/}{PubMed})
#'
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE8218}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_wang
#' @examples
#' mae_wang <- getPCa('wang')
#' @name curatedPCaDatasets_wang
#' @keywords datasets
NULL

#' Weiner et al. MAE-object
#'
#' A MultiAssayExperiment object containing gene expression (gex) and immune 
#' cell estimates for Weiner et al.
#' @format An MAE spanning 838 prostate cancer samples of two cohorts
#' \describe{
#'     \item{gex.rma}{matrix of 17410 rows and 838 columns of gene expression 
#'         data}
#'     \item{cibersort}{matrix with 22 rows and 838 columns, of cibersort based 
#'         deconvolution data}
#'     \item{xcell}{matrix with 39 rows and 838 columns, the xcell deconvolution
#'         of the expression data}
#'     \item{epic}{matrix with 8 rows and 838 columns, the epic deconvolution of
#'         the expression data}
#'     \item{quantiseq}{matrix with 11 rows and 838 columns, the quantiseq 
#'         deconvolution of the expression data}
#'     \item{estimate}{data.frame with 4 rows and 838 columns, of cell types 
#'         based on ESTIMATE method}
#'     \item{scores}{matrix with 4 rows and 838 columns, of risk scores and AR 
#'         scores}
#'     \item{mcp}{matrix with 11 rows and 838 columns, the mcp-counter 
#'         deconvolution of the expression data}
#' }
#'
#' @references (\href{https://pubmed.ncbi.nlm.nih.gov/33568675/}{PubMed})
#' @source \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE157548}
#' @return A MultiAssayExperiment corresponding to the study and its available 
#' omics.
#'
#' @rdname curatedPCaDatasets_weiner
#' @examples
#' mae_weiner <- getPCa('weiner')
#' @name curatedPCaDatasets_weiner
#' @keywords datasets
NULL

---
title: "Overview to curatedPCaData"
output: 
  BiocStyle::html_document
bibliography: references.bib
vignette: >
  %\VignetteIndexEntry{Overview to curatedPCaData}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE,
    cache = TRUE,
    tidy = TRUE,
    width.cutoff = 70
)
```

# Package overview

This overview provides insight into the available datasets (R package version 
`r utils::packageVersion("curatedPCaData")`) provided via `ExperimentHub` cloud 
services. The main data class is a `MultiAssayExperiment` (MAE) object 
compatible with numerous Bioconductor packages.

***

3 different omics base data types and accompanying clinical/phenotype data are 
currently available: 

1. `gex.*` assays contain gene expression values, with the suffix wildcard 
indicating unit or method for gene expression
2. `cna.*` assays contain copy number values, with the suffix wildcard 
indicating method for copy number alterations
3. `mut` assays contain somatic mutation calls
4. `MultiAssayExperiment::colData(maeobj)` contains the clinical metadata 
curated based on a pre-defined template

Their availability is subject to the study in question, and you will find 
coverage of the omics here-in. Furthermore, derived variables based on these 
base data types are provided in the constructed `MultiAssayExperiment` (MAE) 
class objects.

For a comprehensive guide on how to neatly handle such `MAE` objects, refer to 
the MultiAssayExperiment user guide (or cheat-sheets): [MAE User Guide]
(https://www.bioconductor.org/packages/devel/bioc/vignettes/MultiAssayExperiment/inst/doc/MultiAssayExperiment.html) .

# R-package

The `curatedPCaData` package contains a collection of manually curated datasets 
concerning patients diagnosed with prostate cancer. The datasets within this 
package have followed uniform processing and naming conventions to allow users 
to more easily reproduce similar analyses between datasets and spend less time 
concerned with harmonzing data from different sources. 

# Downloading data from ExperimentHub or loading them from local cache

To get a full list of available datasets see the documentation for `getPCa` 
function, or via querying `ExperimentHub`directly for the components used to 
construct `MultiAssayExperiments` for the studies. However, `getPCa` is aimed 
to comprehensively provide readily usable multi-omics compatible MAE-objects.

## All available datasets

Fetching all datasets available in `curatedPCaData`:

```{r message=FALSE}
library(curatedPCaData)

# Use a function to extract all known study short identifiers
studies <- curatedPCaData::getPCaStudies()
studies

# List apply across studies to extract all MAE objects corresponding to the 
# short identifiers
maes <- lapply(studies, FUN=\(id) { curatedPCaData::getPCa(id) })
names(maes) <- studies
```

### Dataset criteria

The datasets were manually selected based on various criteria, such as:

- Primary data availability (preferably raw data available)
- Data platform types and their overlap (gene expression, copy number 
alteration, mutation data, ...)
- End points (e.g. recurrence, Gleason, ...)
- Clinical metadata availability and reliability
- Design of the study

### Studies

The function `getPCa` utilizes the studies' short name for identifying which 
data to extract. An overview into the main datasets is as follows:

```{r studies1, message = FALSE}
# Create a summary table depicting key features in available studies
studytable <- curatedPCaData::getPCaSummaryStudies(maes)
```

```{r studies2, results = 'asis', echo=FALSE}
knitr::kable(studytable, caption = "Key study characteristics")
```

Please note that the TCGA PCa dataset is a subset of the TCGA pan-cancer 
initiative. For a package focused on TCGA exclusively beyond the PRAD subset, 
see the Bioconductor package [curatedTCGAData]
(https://bioconductor.org/packages/release/data/experiment/html/curatedTCGAData.html).

### Citations

The use of `curatedPCaData` ought to be cited with [@Laajala2023].

For individual datasets there-in, the following citations are suggested:

* Abida et al. : [@Abida2019]
* Baca et al. : [@Baca2013]
* Barbieri et al. : [@Barbieri2012]
* Barwick et al. : [@Barwick2010]
* Chandran et al. : [@Chandran2007]
* Friedrich et al. : [@Friedrich2020] 
* Hieronymus et al. : [@Hieronymus2014]
* ICGC (Canadian) : PRAD-CA in [@Zhang2019]
* IGC : GEO accession GSE2109
* Kim et al. : [@Kim2018]
* Kunderfranco et al. : [@Kunderfranco2010], [@PeraldoNeia2011], [@Longoni2012]
* Ren et al. : [@Ren2018]
* Sun et al. : [@Sun2009]
* Taylor et al. : [@Taylor2010]
* TCGA : [@TCGA2015], [@Goldman2020]
* True et al. : [@True2006]
* Wallace et al. : [@Wallace2008]
* Wang et al. : [@Wang2010], [@Jia2011]
* Weiner et al. : [@Weiner2021]

### Curated clinical variables

The `curatedPCaData`-package has been curated with an emphasis on the following 
primary clinical metadata, which were extracted and cleaned up always when 
available:

```{r template, results='asis', echo=FALSE}
data(template_prad)
template <- template_prad
# Add spaces to |-dividers for linechanges
template <- do.call("cbind", lapply(template, FUN = function(x) {
    gsub("|", " | ", x, fixed = TRUE)
}))
knitr::kable(template, caption = "Template for prostate adenocarcinoma clinical 
metadata")
```

### Clinical end-points

Three primary clinical end-points were utilized and are offered in the clinical 
metadata in colData for the MAE-objects, if available:

* Gleason grade/Grade group(s)
* Biochemical Recurrence (BCR)
* Overall Survival (OS)

Below are summaries for each of these endpoints for each study. Of note, OS had 
very few events, thus survival modelling for this end-point may be considered 
unreliable.

Gleason grades:

```{r gleasons1}
# Create a summary table of Gleason grades
gleasons <- curatedPCaData::getPCaSummaryTable(
    maes, 
    var.name = "gleason_grade", 
    vals=5:10
)
```

```{r gleasons2, results = 'asis', echo=FALSE}
knitr::kable(gleasons, caption = "Gleason grades across datasets in 
curatedPCaData")
```

Grade groups:

```{r groups1}
# Create a summary table of grade groups
gradegroups <- curatedPCaData::getPCaSummaryTable(
    maes, 
    var.name = "grade_group", 
    vals=c("<=6", "3+4", "4+3", "7", ">=8")
)
```

```{r groups2, results = 'asis', echo=FALSE}
knitr::kable(gradegroups, caption = "Grade groups across datasets in 
curatedPCaData")
```

Biochemical recurrences:

```{r recurrences1}
# Create a summary table of biochemical recurrences
recurrences <- curatedPCaData::getPCaSummarySurv(
    maes, 
    event.name = "disease_specific_recurrence_status", 
    time.name = "days_to_disease_specific_recurrence"
)
```

```{r recurrences2, results = 'asis', echo=FALSE}
knitr::kable(recurrences, caption = "Disease recurrence end point across 
datasets in curatedPCaData")
```

Overall survival:

```{r os1}
# Create a summary table of overall survival
survivals <- curatedPCaData::getPCaSummarySurv(
    maes, 
    event.name = "overall_survival_status", 
    time.name = "days_to_overall_survival"
)
```

```{r os2, results = 'asis', echo=FALSE}
knitr::kable(survivals, caption = "Overall survival end point across datasets 
in curatedPCaData")
```

## Querying datasets

The function `getPCa` functions as the primary interface with building 
MAE-objects from either live download from `ExperimentHub` or by loading them 
from local cache, if the datasets have been downloaded previously.

The syntax for the function `getPCa(dataset, assays, timestamp, verbose, ...)` 
consists of the following parameters:

- `dataset`: Primary indicator for which study to query from `ExperimentHub`; 
notice that this may only be one of the allowed values.
- `assays`: This indicates which MAE-assays are fetched from the candidate 
ExperimentList. Two names are always required (and are filled if missing): 
`colData` which contains information on the clinical metadata, and `sampleMap` 
which maps the rownames of the metadata to columns in the fetched assay data. 
- `timestamp`: When data is deposited in the `ExperimentHub` resources, they 
are time stamped to avoid ambiguity. The timestamps provided in this parameter 
are resolved from left to right, and the first deposit stamp is `"20230215"`. 
- `verbose`: Logical indicator whether additional information should be printed 
by `getPCa`.
- `...`: Further custom parameters passed on to `getPCa`.

As an example, let us consider querying the TCGA dataset, but suppose only wish 
to extract the gene expression data, and the immune deconvolution results 
derived by the method xCell. Further, we'll request risk and AR scores slot. 
This subset could be retrieved with:

```{r tcgaex}
tcga_subset <- getPCa(
    dataset = "tcga", 
    assays = c("gex.rsem.log", "xcell", "scores"), 
    timestamp = "20230215"
)

tcga_subset
``` 

The standard way of extracting the latest MAE-object with all available assays 
is done via querying with just the dataset name:

```{r ehquery}
mae_tcga <- getPCa("tcga")
mae_taylor <- getPCa("taylor")
```

### Accessing primary data

The primary assay names in the MAE objects for gene expression and copy number 
alteration will consist of two parts. Mutation data is provided as a 
`RaggedExperiment` object.

- Prefix indicating data type, either "gex." or "cna.".
- Suffix indicating unit and processing for the data; for example, a gene 
expression dataset (gex) may have a suffix of "rma" for RMA-processed data, 
"fpkm" for processed RNA-seq data, "relz" for relative z-score normalized 
expression values for tumor-normal gene expression pairs, or "logq" for 
logarithmic quantile-normalized data. The main suffix for copy number 
alteration is the discretized GISTIC alteration calls with values {-2,-1,0,1,2},
although earlier version also provided log-ratios ("logr")
- Mutation data is provided as `RaggedExperiment` objects as "mut".

The standard way for accessing a data slot in MAE could be done for example via:

```{r access}
mae_taylor[["gex.rma"]][1:5, 1:5]
```
The corresponding clinical variables have an accessor function `colData` 
provided by the `MultiAssayExperiment`-package:

```{r clinical}
MultiAssayExperiment::colData(mae_tcga)[1:2, ]
```

While it is ideal to make sure user is using the correct namespaces, the 
`pckgName::` can be omitted as `curatedPCaData` imports necessary packages such
as `MultiAssayExperiment` and their functions should be available in the 
workspace.

### ExperimentHub data listing

In order to access the latest listing of `curatedPCaData` related resources 
available in `ExperimentHub`, consult the `metadata.csv` file delivered with 
the package:

```{r metadat}
metadata <- read.csv(system.file("extdata", "metadata.csv", package = 
    "curatedPCaData"))
head(metadata)
```

## Omics sample count and overlap

```{r samplecountsoverlap}
# Retrieve samples counts across different unique assay names as well as omics 
# overlap sample counts
samplecounts <- curatedPCaData::getPCaSummarySamples(maes)
```

The sample counts in each 'omics separately is listed below:

```{r samplecounts, results='asis', echo=FALSE}
knitr::kable(samplecounts$Samples, caption = "Sample N counts in each omics for 
every MAE object")
```

However, taking intersections between different omics shows that different 
samples were analyzed on different platforms - therefore the effective N counts 
for analyzing multiple 'omics platforms simultaneously is smaller. The overlaps 
between gene expression (GEX), copy number alteration (CNA), and mutations (MUT)
are shown below:

```{r sampleoverlap, results='asis', echo=FALSE}
knitr::kable(samplecounts$Overlap, caption = "Sample N counts for intersections 
between different omics")
```

# Derived variables

In `curatedPCaData` we refer to derived variables as further downstream 
variables, which have been computed based on primarily data. For most cases, 
this was done by extracting key gene information from the `gex.*` assays and 
pre-computing informative downstream markers as described in their primary 
publications.

## Immune deconvolution

Tumor progression depends on the immune cell composition in the tumor 
microenvironment. The '[immunedeconv](https://github.com/icbi-lab/immunedeconv)'
package consists of different computational methods to computationally estimate 
immune cell content using gene expression data. In addition, CIBERTSORTx is 
provided externally, as this method required registered access. For user 
convenience, it has been run separately and provided as a slot in the MAE 
objects. The other methods have been run using the `immunedeconv` package 
[@Sturm2019] and code for reproducing these derived variables are provided 
alongside the package.

In this package, we provide estimates of immune cell content from the following 
deconvolution methods:

- quanTIseq
- xCell
- EPIC
- MCP counter
- CIBERSORT(x)
- ESTIMATE

The estimates from each of these methods are stored in the MAE object as a 
seperate assay as shown for example in the Taylor dataset
```{r}
mae_taylor
```

To access the quantiseq results for the Taylor et. al dataset, these 
pre-computed values can be obtained from the corresponding slot in the 
MAE-object:
```{r}
head(mae_taylor[["cibersort"]])[1:5, 1:3]
```

Similarly to access results from the other immune deconvolution methods, the 
following assays/experiments are also available:
```{r}
head(mae_taylor[["quantiseq"]])[1:5, 1:3]
head(mae_taylor[["xcell"]])[1:5, 1:3]
head(mae_taylor[["epic"]])[1:5, 1:3]
head(mae_taylor[["mcp"]])[1:5, 1:3]
```

Each row of the deconvolution matrix represents the content of a certain immune 
cell type and the columns represent the patient sample IDs. The variables on 
the rows are specific for each method. Further, it should be noted that not all 
methods could be run on all datasets due to lack of overlap in genes of 
interest.

## Risk scores and other metrics

The slot `scores` is used to provide key risk scores or other informative 
metrics based on the primary data. These scores can be accessed as a matrix as 
if they were variables on an assay with this name:

```{r scores}
mae_tcga[["scores"]][, 1:4]
```

The following PCa risk scores are offered:

- Decipher `(rowname: decipher)` [@Herlemann2019]
- Oncotype DX `(rowname: oncotype)` [@Knezevic2013]
- Prolaris `(rowname: prolaris)` [@NICE2018]

Further, the 20-gene Androgen Receptor (AR) score is calculated as described 
in the TCGA's Cell 2015 paper:

- AR score `(rowname: ar_score)` [@TCGA2015]

# Single study example for Taylor et al.

Here, a brief example on how to download and process a single study is 
provided. The example data is of Taylor et al. [@Taylor2010], also known as 
the MSKCC dataset.

## Downloading the MAE-object

A character vector with the short study ID is used to download the MAE 
object; we will focus only on the primary prostate cancer samples and 
CNA (GISTIC) and GEX:

```{r}
taylor <- getPCa("taylor", 
    assays = c("gex.rma", "cna.gistic"),
    sampletypes = "primary"
)

class(taylor) 

taylor
```

One typical end-point is an object of type `Surv`, exported from the 
`survival`-package. We will create this end-point for biochemical 
recurrence:

```{r}
library(survival)
# BCR events
taylor_bcr <- colData(taylor)$disease_specific_recurrence_status
# BCR events / censoring follow-up time
taylor_fu <- colData(taylor)$days_to_disease_specific_recurrence

taylor_surv <- Surv(event = taylor_bcr, time = taylor_fu)

class(taylor_surv)

head(taylor_surv)

```

With the response vector of type `Surv`, one can plot and analyze multiple 
survival modelling related tasks.

## Kaplan-Meier curves

One of the most common ways to depict survival curves (here BCR events), is 
a Kaplan-Meier (KM) curve. Gleason grade is known to be a good prognostic 
factor for BCR, thus a KM curve in respect to biopsy Gleason grade shows 
differences in prognosis.

For this visualization, package `survminer` offers a variety of functions 
building on top of `ggplot`:

```{r}
library(survminer)

taylor_bcr_gleason <- data.frame(bcr = taylor_surv, 
    gleason = colData(taylor)$gleason_grade)

fit <- survfit(bcr ~ gleason, data = taylor_bcr_gleason)
ggsurvplot(fit, 
    data = taylor_bcr_gleason, 
    ylab = "Biochemical recurrence free proportion",
    risk.table = TRUE,
    size = 1,
    pval = TRUE,
    ggtheme = theme_bw()
    )
```

For more settings for the KM plots, see documentation for 
`survminer::ggsurvplot`.

## Cox regression

Functions `longFormat` and `wideFormat` from `MultiAssayExperiment` are 
essential for extracting multi-omics data and metadata in the right format. 
For the purposes of Cox regression, we will utilize `wideFormat`:

```{r}
taylor_coxdat <- MultiAssayExperiment::wideFormat(taylor["PTEN",,],
    colDataCols = c("age_at_initial_diagnosis", "gleason_grade",
    "disease_specific_recurrence_status", 
    "days_to_disease_specific_recurrence"))

taylor_coxdat <- as.data.frame(taylor_coxdat)

taylor_coxdat$y <- Surv(
    time = taylor_coxdat$days_to_disease_specific_recurrence,
    event = taylor_coxdat$disease_specific_recurrence_status)
    
head(taylor_coxdat)    
```

We'll construct a simple Cox proportional hazards model with few variables; 
PTEN is a known tumor suppressor gene, so changes in its copy number or gene 
expression levels could also play a role in biochemical recurrence.

```{r}
coxmodel <- coxph(y ~ cna.gistic_PTEN + gex.rma_PTEN + gleason_grade, 
    data = taylor_coxdat)
coxmodel
```

In this case we took the GISTIC normalized PTEN amplification as well as 
its RMA-normalized gene expression. We notice that both are statistically 
significant Cox regression coefficients together with Gleason grade. 

# Session info

```{r session}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/curatedPCaData-package.R
\docType{package}
\name{curatedPCaData}
\alias{curatedPCaData}
\alias{curatedPCaData-package}
\title{curatedPCaData}
\description{
The package curatedPCaData offers a selection of annotated
prostate cancer datasets featuring multiple omics, manually
curated metadata, and derived downstream variables. The studies
are offered as MultiAssayExperiment (MAE) objects via ExperimentHub,
and comprise of clinical characteristics tied to gene expression,
copy number alteration and somatic mutation data. Further, downstream
features computed from these multi-omics data are offered. Multiple
vignettes help grasp characteristics of the various studies and provide
example exploratory and meta-analysis of leveraging the multiple
studies provided here-in.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/Syksy/curatedPCaData}
  \item Report bugs at \url{https://github.com/Syksy/curatedPCaData/issues}
}

}
\author{
\strong{Maintainer}: Teemu Daniel Laajala \email{teelaa@utu.fi} (\href{https://orcid.org/0000-0002-7016-7354}{ORCID})

Other contributors:
\itemize{
  \item Jordan Creed \email{jordan.h.creed@moffitt.org} [contributor]
  \item Christelle Colin Leitzinger \email{christelle.colinleitzinger@moffitt.org} [contributor]
  \item Varsha Sreekanth \email{varsha.sreekanth@cuanschutz.edu} [contributor]
  \item Federico Calboli \email{federico.calboli@luke.fi} [contributor]
  \item Kalaimathy Singaravelu \email{kalsin@utu.fi} [contributor]
  \item Michael Orman \email{michael.orman@cuanschutz.edu} [contributor]
  \item Alex Soupir \email{Alex.Soupir@moffitt.org} [contributor]
  \item Anni Halkola \email{ansuha@utu.fi} [contributor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_abida}
\alias{curatedPCaDatasets_abida}
\title{Abida et al. MAE-object}
\format{
A MAE object spanning 444 castrate resistant prostate cancer samples.
\describe{
    \item{cna.gistic}{matrix with 20291 rows and 444 columns, from GISTIC 
        discretized copy number alteration calls.}
    \item{gex.relz}{matrix with 18971 rows and 266 columns, from z-score 
        normalized expression in relative to paired normals.}
    \item{mut}{RaggedExperiment with 63184 rows and 444 columns, mutation 
        data from cbioportal}
    \item{cibersort}{matrix with 22 rows and 261 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 261 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 261 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 261 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 261 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 261 columns, of risk scores and AR 
        scores}
    \item{mcp}{mmatrix with 11 rows and 261 columns, of mcp-counter based 
        deconvolution data}

}
}
\source{
\url{https://www.cbioportal.org/study/summary?id=prad_su2c_2019}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex), copy
number alteration (cna), mutations (mut) and immune cell estimates for Abida 
et al.
}
\details{
the clinical data refers to a sample of 444 tumors collected in 429 
patients. The tissue was collected primarily at metastatic sites rather than 
from the prostate.
}
\examples{
mae_abida <- getPCa('abida')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/31061129/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_hieronymus}
\alias{curatedPCaDatasets_hieronymus}
\title{Hieronymus et al. MAE-object}
\format{
A MAE object spanning 104 tumor samples
\describe{
    \item{cna.gistic}{matrix with 18026 rows and 104 columns, from GISTIC 
        discretized copy number alteration calls}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE54691}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing copy number alteration (cna) for 
Hieronymus et al.
}
\details{
The data comprises of 104 samples, for which are available clinical 
data and Copy Number Alteration, but no gene expression data -- thus no 
deconvolution results are available.
}
\examples{
mae_hieronymus <- getPCa('hieronymus')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/25024180/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_weiner}
\alias{curatedPCaDatasets_weiner}
\title{Weiner et al. MAE-object}
\format{
An MAE spanning 838 prostate cancer samples of two cohorts
\describe{
    \item{gex.rma}{matrix of 17410 rows and 838 columns of gene expression 
        data}
    \item{cibersort}{matrix with 22 rows and 838 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 838 columns, the xcell deconvolution
        of the expression data}
    \item{epic}{matrix with 8 rows and 838 columns, the epic deconvolution of
        the expression data}
    \item{quantiseq}{matrix with 11 rows and 838 columns, the quantiseq 
        deconvolution of the expression data}
    \item{estimate}{data.frame with 4 rows and 838 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 838 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 11 rows and 838 columns, the mcp-counter 
        deconvolution of the expression data}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE157548}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
A MultiAssayExperiment object containing gene expression (gex) and immune 
cell estimates for Weiner et al.
}
\examples{
mae_weiner <- getPCa('weiner')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/33568675/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_taylor}
\alias{curatedPCaDatasets_taylor}
\title{Taylor et al. MAE-object}
\format{
An MAE object spanning 218 men with prostate cancer
\describe{
    \item{cna.gistic}{matrix with 17832 rows and 194 columns, of gistic 
        values for copy number alteration data}
    \item{cna.logr}{matrix with 18062 rows and 218 columns, of log-ratios for
        copy number alteration data}
    \item{gex.rma}{matrix with 17410 rows and 179 columns, of gene expression
        data}
    \item{mut}{RaggedExperiment with 90 rows and 43 columns, of mutation 
        data}
    \item{cibersort}{matrix with 22 rows and 179 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 179 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 179 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 179 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 179 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 179 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 11 rows and 179 columns, of mcp-counter based 
        deconvolution data}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE21035}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex), copy
number alteration (cna), mutations and immune cell estimates from Taylor et 
al.
}
\details{
Note that there is lack of overlap between the omics provided for 
each sample.
}
\examples{
mae_taylor <- getPCa('taylor')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/20579941/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getpcasummaries.R
\name{getPCaStudies}
\alias{getPCaStudies}
\title{Create a vector of unique study identifiers available in curatedPCaData}
\usage{
getPCaStudies(uniqs = TRUE)
}
\arguments{
\item{uniqs}{Should only unique instances be returned; by default TRUE}
}
\value{
A character vector with short study identifiers, e.g. 'abida', 
'baca', ...
}
\description{
This function accesses the metadata available together with the 
curatedPCaData package and creates a vector of unique study identifier names 
available in the ExperimentHub resources. This vector is useful, for example,
when applying the 'getPCa' to create MAE from the studies.
}
\details{
Uses the internal 'metadata.csv' file, which is also used to provide
the metadata
available in ExperimentHub.
}
\examples{
studyids <- getPCaStudies()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_barwick}
\alias{curatedPCaDatasets_barwick}
\title{Barwick et al. MAE-object}
\format{
A MAE object spanning 146 prostate cancer samples.
\describe{
    \item{gex.logq}{matrix with 482 rows and 146 columns, for the 
        log-quantile normalized gene expression data}
    \item{cibersort}{matrix with 22 rows and 139 columns, of cibersort based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 139 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 139 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 3 rows and 139 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 4 rows and 139 columns, of mcp-counter based 
        deconvolution data}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE18655}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex) and immune cell 
estimates for Barwick et al.
}
\details{
Barwick et al. uses an older customized DASL array; therefore its 
gene coverage is lower, and many downstream methods fail due to lack of gene 
overlap.
}
\examples{
mae_barwick <- getPCa('barwick')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/22610119/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getpca.R
\name{getPCa}
\alias{getPCa}
\title{Construct Prostate Cancer MultiAssayExperiment object from specific cohort}
\usage{
getPCa(dataset, assays, timestamp, sampletypes, verbose = FALSE, ...)
}
\arguments{
\item{dataset}{character() of PCa cancer cohort names
(e.g., 'abida')}

\item{assays}{character() A vector of PCa assays. If not included, 
returns all available for the selected dataset; see below for more details.}

\item{timestamp}{character(1) "20230215" indicating the data version to 
obtain from `ExperimentHub`. See `timestamp` section details.}

\item{sampletypes}{A character vector of sample types to include in the MAE.
If the parameter is missing, then all samples are returned. Allowed values
are: 'primary', 'metastatic', 'normal', 'BPH', 'atrophic'}

\item{verbose}{logical(1) Whether to show the dataset currenlty being
(down)loaded (default TRUE)}

\item{...}{Additional arguments passed on to the
\code{\link[ExperimentHub:ExperimentHub-class]{ExperimentHub}}
constructor}
}
\value{
a \linkS4class{MultiAssayExperiment} of the specified assays and
cancer cohort
}
\description{
curatedPCaData provides \linkS4class{MultiAssayExperiment}
container objects that are constructed from ExperimentHub.
User provides PCa dataset name (see list on the overview-vignette or 
help files).
}
\details{
This function will check against available resources in
ExperimentHub.
For a list of datasets, see the overview-vignette or below dataset listing.
}
\section{Available datasets}{


Following shortnames can be used with getPCa to query for their omics from
ExperimentHub. For more detailed description of the studies, see their
corresponding R documentation file. Further details are reported in the 
overview-vignette.

\preformatted{

Shortname      Rd documentation file           Longer name(s)
----------------------------------------------------------------------------

abida        curatedPCaDatasets_abida        Abida et al.
baca         curatedPCaDatasets_baca         Baca et al.
barbieri     curatedPCaDatasets_barbieri     Barbieri et al.
barwick      curatedPCaDatasets_barwick      Barwick et al.
chandran     curatedPCaDatasets_chandran     Chandran et al., Yu et al.
friedrich    curatedPCaDatasets_friedrich    Friedrich et al.
hieronymus   curatedPCaDatasets_hieronymus   Hieronymus et al.
icgcca       curatedPCaDatasets_icgcca       ICGC Canadian subset
igc          curatedPCaDatasets_igc          International Genomics Consortium (PCa subset)
kim          curatedPCaDatasets_kim          Kim et al.
kunderfranco curatedPCaDatasets_kunderfranco Kunderfranco et al.
ren          curatedPCaDatasets_ren          Ren et al.
sun          curatedPCaDatasets_sun          Sun et al.
taylor       curatedPCaDatasets_taylor       Taylor et al.
tcga         curatedPCaDatasets_tcga         The Cancer Genome Atlas (PCa subset, PRAD-prefix)
true         curatedPCaDatasets_true         True et al.
wallace      curatedPCaDatasets_wallace      Wallace et al.
wang         curatedPCaDatasets_wang         Wang et al.
weiner       curatedPCaDatasets_weiner       Weiner et al.
}
}

\section{Available Assays}{


The list of ExperimentList assay names and their descriptions.
These assays can be entered as part of the \code{assays} argument in the
main function.
\preformatted{

ExperimentList data types   Description
----------------------------------------------------------------------------

gex.rma            Gene expression values (RMA normalized)
gex.logq                                  (Log-quantile)
gex.relz                                  (Relative z-scores)
gex.logr                                  (Log-ratios)
gex.rsem.log                              (Log-RSEM)
cna.gistic         Copy number alteration (GISTIC calls)
cna.logr                                  (Log-ratios)
mut                Somatic mutation calls
cibersort          Immune deconvolution as estimated by CIBERSORTx
xcell                                                   xCell
epic                                                    EPIC
quantiseq                                               quanTIseq
mcp                                                     MCP-counter
estimate                                                ESTIMATE
scores             Various risk and AR scores; see vignette references.
}
}

\section{timestamp}{
 "20230215"
The timestamp is updated in case the data is updated. In this case, this
section describes the changes made for new timestamps. At this time, the
only data deposit is from 2023, Feb 15th, indicated by "20230215".
}

\examples{
mae_taylor <- getPCa(
    dataset = "taylor", timestamp = "20230215"
)

}
\seealso{
curatedPCaData-package
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_barbieri}
\alias{curatedPCaDatasets_barbieri}
\title{Barbieri et al. MAE-object}
\format{
A MAE object spanning prostate adenocarcinomas from Barbieri et. al
\describe{
    \item{cna.gistic}{matrix with 20844 rows and 109 columns, from GISTIC 
        discretized copy number alteration calls}
    \item{gex.relz}{matrix with 17917 rows and 31 columns, from z-score 
        normalized expression in relative to paired normals.}
    \item{mut}{RaggedExperiment with 5737 rows and 112 columns, mutation 
        data from cbioportal}
    \item{cibersort}{matrix with 22 rows and 31 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 31 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 31 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 31 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 31 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 31 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 11 rows and 31 columns, of mcp-counter based 
        deconvolution data}
}
}
\source{
\url{https://www.cbioportal.org/study/summary?id=prad_broad}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex), copy
number alteration (cna), mutations (mut) and immune cell estimates for 
Barbieri et al.
}
\details{
The data comprises of primary localised prostate tumors from two 
cohorts, the Weill Cornell Medical College (WCMC; New York, NY), and the 
Uropath (Perth, Australia), which commercially provides banked urological 
tissues. None of the samples comes from patients who had received prior 
treatment for prostate cancer.
}
\examples{
mae_barbieri <- getPCa('barbieri')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/22610119/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_tcga}
\alias{curatedPCaDatasets_tcga}
\title{TCGA MAE-object}
\format{
An MAE object spanning 369 men with prostate cancer
\describe{
    \item{cna.gistic}{matrix with 23151 rows and 492 columns, from GISTIC 
        discretized copy number alteration calls}
    \item{gex.rsem.log}{matrix with 19658 rows and 461 columns, of gene 
        expression data}
    \item{mut}{RaggedExperiment with 30897 rows and 495 columns, of mutation 
        data}
    \item{cibersort}{matrix with 22 rows and 550 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 461 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 461 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 461 columns, of quantiseq based 
        deconvolution data}
    \item{mcp}{matrix with 11 rows and 461 columns, of mcp-counter based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 461 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 416 columns, of risk scores and AR 
        scores}
}
}
\source{
\url{https://xenabrowser.net/datapages/?cohort=GDC\%20TCGA\%20Prostate\%20Cancer\%20(PRAD)}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex), copy
number alteration (cna), mutations and immune cell estimates from GDC TCGA.
}
\details{
TCGA data was obtained from the latest GDC's XenaBrowser release.
}
\examples{
mae_tcga <- getPCa('tcga')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/26544944/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_chandran}
\alias{curatedPCaDatasets_chandran}
\title{Chandran et al., Yu et al. MAE-object}
\format{
An MAE object spanning 171 men with prostate cancer
\describe{
    \item{gex.rma}{matrix with 9007 rows and 171 columns, for the gene 
        expression data}
    \item{cibersort}{matrix with 22 rows and 171 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 171 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 171 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 171 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 171 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 171 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 11 rows and 171 columns, of mcp-counter based 
        deconvolution data}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE6919}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex) and immune cell 
estimates for Chandran et al., Yu et al.
}
\examples{
mae_chandran <- getPCa('chandran')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/17430594/}{PubMed}) 
(\href{https://pubmed.ncbi.nlm.nih.gov/15254046/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getpcasummaries.R
\name{getPCaSummaryStudies}
\alias{getPCaSummaryStudies}
\title{Create a summary table of key characteristics for each study}
\usage{
getPCaSummaryStudies(maes)
}
\arguments{
\item{maes}{A list of MAE objects or a character vector with study short ids}
}
\value{
A table with study names, references, sample counts, data source, and 
other notes.
}
\description{
Create a summary table of key characteristics for each study
}
\examples{
studies <- getPCaStudies(uniqs = TRUE)
tab <- getPCaSummaryStudies(studies)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_ren}
\alias{curatedPCaDatasets_ren}
\title{Ren et al. MAE-object}
\format{
An MAE object spanning 65 men with prostate cancer
\describe{
    \item{gex.relz}{matrix with 21046 rows and 65 columns, of gene expression
        data}
    \item{mut}{RaggedExperiment with 50625 rows and 65 columns, of mutation 
        data from cbioportal}
    \item{cibersort}{matrix with 22 rows and 65 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 65 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 65 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 65 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 65 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 65 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 11 rows and 65 columns, of mcp-counter based 
        deconvolution data}
}
}
\source{
\url{https://www.cbioportal.org/study/summary?id=prad_eururol_2017}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex), mutations and 
immune cell estimates from Ren et al.
}
\details{
The data contains 14 disease free benign prostate hyperplasia 
samples and 53 prostate cancer samples.
}
\examples{
mae_ren <- getPCa('ren')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/28927585/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_friedrich}
\alias{curatedPCaDatasets_friedrich}
\title{Friedrich et al. MAE-object}
\format{
An MAE object spanning 255 men with prostate cancer
\describe{
    \item{gex.logq}{matrix with 23097 rows and 255 columns, for the 
        log-quantile normalized gene expression data}
    \item{cibersort}{matrix with 22 rows and 255 columns, of cibersort based 
        deconvolution data}
    \item{xcell}{matrix with 39 rows and 255 columns, of xcell based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 255 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 255 columns, of quantiseq based 
        deconvolution data}
    \item{estimate}{data.frame with 4 rows and 255 columns, of cell types 
        based on ESTIMATE method}
    \item{scores}{matrix with 4 rows and 255 columns, of risk scores and AR 
        scores}
    \item{mcp}{matrix with 11 rows and 255 columns, of mcp-counter based 
        deconvolution data}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE134051}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex) and immune cell 
estimates for Friedrich et al.
}
\details{
The data comprises of 255 samples, with 164 primary tumors samples, 
52 adjacent normal samples, and 39 benign prostate hyperplasia samples.  
This dataset includes in its totality the 164 samples analysed in Kreutz 
et al. 2020.
}
\examples{
mae_friedrich <- getPCa('friedrich')
}
\references{
(\href{https://pubmed.ncbi.nlm.nih.gov/32365858/}{PubMed}) 
(\href{https://pubmed.ncbi.nlm.nih.gov/32631745/}{PubMed})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{curatedPCaDatasets_baca}
\alias{curatedPCaDatasets_baca}
\title{Baca et al. MAE-object}
\format{
A MAE object spanning 56 prostate cancer samples.
\describe{
    \item{cna.gistic}{matrix with 20124 rows and 56 columns, from GISTIC 
        discretized copy number alteration calls.}
    \item{mut}{RaggedExperiment with 2734 rows and 57 columns, mutation data 
        from cbioportal}
}
}
\source{
\url{https://www.cbioportal.org/study/summary?id=prad_broad_2013}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing copy number alteration (cna) and 
mutations for Baca et al.
}
\examples{
mae_baca <- getPCa('baca')
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{template_prad}
\alias{template_prad}
\title{Template for curatedPCaData clinical fields}
\format{
An object of class \code{data.frame} with 68 rows and 6 columns.
}
\usage{
template_prad
}
\value{
A data.frame of the PCa template
}
\description{
This data frame contains the clinical fields which were
the aim for extraction when gathering metadata for each dataset.
Variable types, ranges, and description is reported.
}
\examples{
data(template_prad)
head(template_prad)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getpcasummaries.R
\name{getPCaSummaryTable}
\alias{getPCaSummaryTable}
\title{Create summary tables for colData metadata in curatedPCaData}
\usage{
getPCaSummaryTable(maes, var.name, vals, nas = TRUE)
}
\arguments{
\item{maes}{List of MultiAssayExperiment objects to summarize}

\item{var.name}{Name of the metadata variable to look for in colData}

\item{vals}{Possible values for the metadata variable to tabulate}

\item{nas}{Whether NA or values other than those contained in 'vals' should 
be appended as extra columns}
}
\value{
A matrix describing the tabulates 'vals' and their proportions along 
with missingness
}
\description{
Create a variable value availability tables; NA-value in addition to provided
'vals' and Other-values for debugging or anomalies
}
\examples{
mae_taylor <- getPCa('taylor')
mae_tcga <- getPCa('tcga')
getPCaSummaryTable(maes = list(Taylor = mae_taylor, TCGA = mae_tcga), 
    var.name = 'gleason_grade', vals = 5:10)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getpcasummaries.R
\name{getPCaSummarySamples}
\alias{getPCaSummarySamples}
\title{Create a summary table for sample counts for different omics across the 
datasets in curatedPCaData}
\usage{
getPCaSummarySamples(maes)
}
\arguments{
\item{maes}{List of MultiAssayExperiment objects to summarize}
}
\value{
A list with two elements: first is a matrix depicting sample counts 
in each unique assay name for the studies; 
second one is a matrix with sample count overlap between the three main omics
(GEX = gene expression; CNA = copy number alteration; MUT = somatic 
mutations).
}
\description{
Create two types of summary matrices; first one takes all unique assay names,
and summarizes sample counts available for all provided studies. The second 
matrix takes gene expression, copy number alteration, and somatic mutation 
data, and displays sample counts for each omic individually, as well as all 
combinations of intersections for samples available for multi-omics.
}
\examples{
mae_taylor <- getPCa('taylor')
mae_tcga <- getPCa('tcga')
getPCaSummarySamples(maes = list(Taylor = mae_taylor, TCGA = mae_tcga))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getpcasummaries.R
\name{getPCaSummarySurv}
\alias{getPCaSummarySurv}
\title{Create survival summary for metadata in curatedPCaData}
\usage{
getPCaSummarySurv(maes, event.name, time.name)
}
\arguments{
\item{maes}{List of MultiAssayExperiment objects to summarize}

\item{event.name}{Name for the colData column for the end-point event; 
typically one of 'days_to_disease_specific_recurrence' or 
'days_to_overall_survival'}

\item{time.name}{Name for the colData column for the time for the end-point 
until event or censoring; typically one of 
'disease_specific_recurrence_status' or 'overall_survival_status'}
}
\value{
A matrix describing the event and follow-up information as character 
strings
}
\description{
Create summary for survival-like columns (0/1 event with follow-up time) for 
colData metadata in curatedPCaData
}
\examples{
mae_taylor <- getPCa('taylor')
mae_tcga <- getPCa('tcga')
getPCaSummarySurv(maes = list(Taylor = mae_taylor, TCGA = mae_tcga), 
    event.name = 'disease_specific_recurrence_status', time.name = 
    'days_to_disease_specific_recurrence')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curatedPCaDatasets_true}
\alias{curatedPCaDatasets_true}
\title{True et al. MAE-object}
\format{
An MAE object spanning 32 men with prostate cancer
\describe{
    \item{gex.logr}{matrix with 3615 rows and 32 columns, of gene expression 
        data}
    \item{cibersort}{matrix with 22 rows and 32 columns, of cibersort based 
        deconvolution data}
    \item{epic}{matrix with 8 rows and 32 columns, of epic based 
        deconvolution data}
    \item{quantiseq}{matrix with 11 rows and 32 columns, of quantiseq based 
        deconvolution data}
    \item{mcp}{matrix with 7 rows and 32 columns, of mcp-counter based 
        deconvolution data}
    \item{scores}{matrix with 2 rows and 32 columns, of risk scores and AR 
        scores}
    \item{estimate}{data.frame with 4 rows and 32 columns, of cell types 
        based on ESTIMATE method}
}
}
\source{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE5132}
}
\value{
A MultiAssayExperiment corresponding to the study and its available 
omics.
}
\description{
MultiAssayExperiment object containing gene expression (gex) and immune cell 
estimates from True et al.
}
\details{
The expression data for this dataset was produced by an older two 
colour chip that provides the relative expression levels for between tumor 
and normal.  Due to the chip type, there was a lack of gene overlap with 
some of the downstream methods, thus some downstream methods are missing.
}
\examples{
mae_true <- getPCa('true')
}
\keyword{datasets}
